         PRINT NOGEN
         BEGIN NAME=QCE210,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  Segment Name:  qce210.asm                                          *
*                                                                     *
*  Related Segments:  qce2.c                                          *
*                                                                     *
*  Abstract:    Member of qce2  module                                *
*                                                                     *
*                                                                     *
*  Description: This segment tests PRLGC 31/64 bit support.           *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  INTERFACE REQUIREMENTS:                                            *
*                                                                     *
*  Dependencies:  None                                                *
*                                                                     *
*  Restrictions:  None                                                *
*                                                                     *
* ------------------------------------------------------------------- *
*                                                                     *
*  Input:                                                             *
*                                                                     *
*  Output:                                                            *
*                                                                     *
*                                                                     *
*  ECB WORKAREA USAGE                                                 *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
*                                                                     *
*   INTERNAL:                                                         *
*                                                                     *
*   Register conventions:                                             *
*                                                                     *
*   R2 -- Base Register as specified by PRLGC                         *
*                                                                     *
*                                                                     *
*---------------------------------------------------------------------*
         PRINT GEN
*---------------------------------------------------------------------*
*           31-bit check                                              *
*---------------------------------------------------------------------*
            PRLGC ENAME=test_prlgc_31,BASE=R7,AMODE=31,STACK=R13,      X
               FRAMESIZE=HEAPSTK_LEN
            USING HEAPSTK,ICST_WRK
            MVC EYECATCHER,QCE210_31_EYECATCHER
            LA R2,MSG31_3                    SEND BEGIN MSG
            BAS R1,GOODMSG31                 WTOPC
            EPSW R4,R5                       GET PSW
            SLL  R4,31                       ISOLATE 64-BIT IND
            LTR  R4,R4                       TEST 64-BIT IND
            BNZ  NOT31                       IF ON..NOT 31-BIT MODE
            LA   R2,MSG31_1                  SEND OK MSG
            BAS  R1,GOODMSG31                WTOPC
            CPROC RETURN=ui,malloc,(ui)
            LH   R2,=H'100'                  SET MALLOC SIZE
            CALLC malloc(R2)
            LTR   R15,R15                    TEST RETURN
            BNZ   GOOD_31
            LA   R2,MSG31_4                  FAILED MALLOC MSG
            BAS  R1,BADMSG31                 WTOPC
            B    OUT31
GOOD_31     DS    0H
            FREEC BLOCK=R15
            CSTKC GET=R13                    RESTORE STACK FRAME
            CLC  EYECATCHER,QCE210_31_EYECATCHER
            BE   STACK31_OK
            LA   R2,MSG31_5                  SEND STACK FAILED MSG
            BAS  R1,BADMSG31                 WTOPC
            BE   OUT31
STACK31_OK  DS   0H
            LA R2,MSG31_6                    STACK OK MSG
            BAS R1,GOODMSG31                  WTOPC
            BE   OUT31
NOT31       DS   0H
            LA R2,MSG31_2                    FAILED MSG
            BAS R1,BADMSG31                  WTOPC
OUT31       DS   0H
            EPLGC  RC=NONE                   RETURN
            SPACE
GOODMSG31   DS   0H
            CLI   EBW008,1                   CONTINUOUS MODE?
            BZ    SKIPMSG_31
            WTOPC TEXTA=(R2),                                          X
               SUB=(DECA,EBW000),                                      X
               NUM=93,PREFIX=SOLD
SKIPMSG_31  DS   0H
            BR R1                            RETURN
            SPACE
BADMSG31    DS   0H
            WTOPC TEXTA=(R2),                                          X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=193,PREFIX=SOLD
            BR R1                            RETURN
            SPACE
QCE210_31_EYECATCHER DC C'QCE210_31_EYECATCHER'
            DS    0H
MSG31_1     DC    AL1(MSG31_1E-MSG31_1B)
MSG31_1B    DC    C'QCE2: CASE .. PSW Check OK',AL1(#CAR)
MSG31_1E    EQU   *
MSG31_2     DC    AL1(MSG31_2E-MSG31_2B)
MSG31_2B    DC    C'QCE2: CASE .. PSW Check FAILED',AL1(#CAR)
MSG31_2E    EQU   *
MSG31_3     DC    AL1(MSG31_3E-MSG31_3B)
MSG31_3B    DC    C'QCE2: CASE .. TESTING PRLGC 31-BIT',AL1(#CAR)
MSG31_3E    EQU   *
MSG31_4     DC    AL1(MSG31_4E-MSG31_4B)
MSG31_4B    DC    C'QCE2: CASE .. MALLOC FAILED',AL1(#CAR)
MSG31_4E    EQU   *
MSG31_5     DC    AL1(MSG31_5E-MSG31_5B)
MSG31_5B    DC    C'QCE2: CASE .. STACK FAILED',AL1(#CAR)
MSG31_5E    EQU   *
MSG31_6     DC    AL1(MSG31_6E-MSG31_6B)
MSG31_6B    DC    C'QCE2: CASE .. PRLGC STACK OK',AL1(#CAR)
MSG31_6E    EQU   *
            LTORG
*---------------------------------------------------------------------*
*           64-bit check                                              *
*---------------------------------------------------------------------*
         PRLGC ENAME=test_prlgc_64,BASE=R7,AMODE=64,STACK=R13,         X
               FRAMESIZE=HEAPSTK_LEN
            USING HEAPSTK,ICST_WRK
            MVC  EYECATCHER,QCE210_64_EYECATCHER
            LA   R2,MSG64_3                  SEND BEGIN MSG
            JAS  R1,GOODMSG64                WTOPC
            EPSW R4,R5                       GET PSW
            SLLG R4,R4,63                    ISOLATE 64-BIT IND
            LTGR R4,R4                       TEST 64-BIT IND
            JZ   NOT64                       IF OFF..NOT 64-BIT
            LA   R2,MSG64_1                  SEND OK MSG
            JAS  R1,GOODMSG64                WTOPC
            CPROC RETURN=ul,malloc64,(ul)
            LGHI  R2,100                     SET MALLOC SIZE
            CALLC malloc64(R2)
            LTGR  R15,R15                    TEST RETURN
            JNZ   GOOD_64
            LA   R2,MSG64_4                  FAILED MALLOC MSG
            JAS  R1,BADMSG64                 WTOPC
            J    OUT64                       RETURN
GOOD_64     DS    0H
            FREEC BLOCK=R15
            CSTKC GET=R13                    RESTORE STACK FRAME
            CLC  EYECATCHER,QCE210_64_EYECATCHER
            JE   STACK64_OK
            LA   R2,MSG64_5                  SEND STACK FAILED MSG
            JAS  R1,BADMSG64                 WTOPC
            J    OUT64                       RETURN
STACK64_OK  DS 0H
            LA   R2,MSG64_6                  SEND STACK OK MSG
            JAS  R1,GOODMSG64                WTOPC
            J    OUT64                       RETURN
NOT64       DS   0H
            LA   R2,MSG64_2                  FAILED MSG
            JAS  R1,BADMSG64                 WTOPC
OUT64       DS   0H
            EPLGC RC=NONE                    RETURN
            SPACE
GOODMSG64   DS   0H
            CLI   EBW008,1                   CONTINUOUS MODE?
            JZ    SKIPMSG_64
            WTOPC TEXTA=(R2),                                          X
               SUB=(DECA,EBW000),                                      X
               NUM=93,PREFIX=SOLD
SKIPMSG_64  DS   0H
            BR R1                            RETURN
            SPACE
BADMSG64    DS   0H
            WTOPC TEXTA=(R2),                                          X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=193,PREFIX=SOLD
            BR R1                            RETURN
            SPACE
QCE210_64_EYECATCHER DC C'QCE210_64_EYECATCHER'
            DS    0H
MSG64_1     DC    AL1(MSG64_1E-MSG64_1B)
MSG64_1B    DC    C'QCE2: CASE .. PSW Check OK',AL1(#CAR)
MSG64_1E    EQU   *
MSG64_2     DC    AL1(MSG64_2E-MSG64_2B)
MSG64_2B    DC    C'QCE2: CASE .. PSW Check FAILED',AL1(#CAR)
MSG64_2E    EQU   *
MSG64_3     DC    AL1(MSG64_3E-MSG64_3B)
MSG64_3B    DC    C'QCE2: CASE .. TESTING PRLGC 64-BIT',AL1(#CAR)
MSG64_3E    EQU   *
MSG64_4     DC    AL1(MSG64_4E-MSG64_4B)
MSG64_4B    DC    C'QCE2: CASE .. MALLOC FAILED',AL1(#CAR)
MSG64_4E    EQU   *
MSG64_5     DC    AL1(MSG64_5E-MSG64_5B)
MSG64_5B    DC    C'QCE2: CASE .. STACK FAILED',AL1(#CAR)
MSG64_5E    EQU   *
MSG64_6     DC    AL1(MSG64_6E-MSG64_6B)
MSG64_6B    DC    C'QCE2: CASE .. PRLGC STACK OK',AL1(#CAR)
MSG64_6E    EQU   *
            LTORG
         GBLC  &BGSECT
HEAPSTK  DSECT
EYECATCHER     DS    CL20
HEAPSTK_LEN    EQU *-HEAPSTK      Length of stack frame
            PRINT NOGEN
&BGSECT  CSECT
            FINIS   QCE210
            END
