/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QME2                                             */
/* DESCRIPTION..... This module serves as an entry point using the   */
/*                  main() function for the Shared Object Linkage    */
/*                  Driver (SOLD) test cases.                        */
/*                                                                   */
/* FUNCTION... QME2 is a function called by test cases               */
/*                     6, 9, 56                                      */
/*             of the SOLD driver. The test case number is passed to */
/*             this function through the parameter array argv and    */
/*             placed into the ECB workarea field EBW000.            */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....                                                        */
/*                                                                   */
/* NORMAL RETURN...                                                  */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/
#include <tpf/tpfapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <c_sold.h>

void QCE2(void);                                                                //C64JK
void QSBF(struct TPF_regs *);                                                   //C64JK

int main(int argc, char **argv)
{
   test_case = atoi(argv[1]);                                                   //C64JK
   test_mode = atoi(argv[2]);                                                   //d10433f_1
   struct TPF_regs regs;                                                        //C64JK
   struct pat *pat_addr;                                                        //d10433f_1
   char prog_name[PAT_PROG_NAME_LEN+PAT_VERS_CODE_LEN+1] = {0};                 //d10875

   if (test_mode == SHOW_VER)  {                                                //f5555
      pat_addr = (void*) tpf_ecbp3()->ce3patg;                                  //f12472
      memcpy(prog_name, pat_addr->patname, PAT_PROG_NAME_LEN+PAT_VERS_CODE_LEN);//d10875
      show_prog_version(prog_name, pat_addr->patacnum);                         //f12305
   }

   switch(test_case) {
   case 6:
       QCE2();                                                                  //C64JK
       break;
   case 9:
       if( qsc2a(1881, 101880, -41486, -75000, 10000, 4728, qsc2b) != 2003 ) {  //C64JK
          bad_return_msg("QME2","QSC2", test_case);                             //C64JK
       }
       break;
   case 56:
       /* Set up registers */
       regs.r0 = 522149;                                                        //C64JK
       regs.r4 = 478641;                                                        //C64JK
       regs.r5 = 83379;                                                         //C64JK
       regs.r6 = -39871;                                                        //C64JK
       QSBF(&regs);                                                             //C64JK
       /* Check results */
       if( (char)regs.r7 != 'P' )                                               //C64JK
          bad_return_msg("QME2", "QSBF", test_case);                            //C64JK
       break;
   default:
       bad_case_msg("QME2", test_case);                                         //C64JK
   }
return 0;
}
