/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QME4                                             */
/* DESCRIPTION..... This module serves as an entry point using the   */
/*                  main() function for the Shared Object Linkage    */
/*                  Driver (SOLD) C++ function trace.                */
/*                                                                   */
/* FUNCTION... QME4 is a function called by test case 100            */
/*             of the SOLD driver. At this time this is the only     */
/*             test case to use this function, as it is for C++      */
/*             function trace, and the rest of the SOLD is in C.     */
/*             There is no plan for C++ expansion, so no test case   */
/*             information is provided.                              */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....                                                        */
/*                                                                   */
/* NORMAL RETURN...                                                  */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <tpf/tpfapi.h>
#include <cpp_sold.hpp>

/*-------------------------------------------------------------------*/
/* Subroutines to test char parameters and char return parameter     */
/*-------------------------------------------------------------------*/
char testchar6(char zz61, char zz62, char zz63, char zz64,
               char zz65, char zz66){
   char x = 'O';
   return(x);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned char parameters and                  */
/* unsigned char return parameter                                    */
/*-------------------------------------------------------------------*/
unsigned char testuchar6(unsigned char zz61, unsigned char zz62,
                         unsigned char zz63, unsigned char zz64,
                         unsigned char zz65, unsigned char zz66){
   unsigned char x = 'P';
   return(x);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test short parameters and short return parameter   */
/*-------------------------------------------------------------------*/
short testshort6(short zz61, short zz62, short zz63,
                 short zz64, short zz65, short zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned short parameters and                 */
/* unsigned short return parameter                                   */
/*-------------------------------------------------------------------*/
unsigned short testushort6(unsigned short zz61, unsigned short zz62,
                           unsigned short zz63, unsigned short zz64,
                           unsigned short zz65, unsigned short zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test int parameters and int return parameter   */
/*-------------------------------------------------------------------*/
int testint6(int zz61, int zz62, int zz63, int zz64, int zz65,int zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned int parameters and                   */
/* unsigned int return parameter                                     */
/*-------------------------------------------------------------------*/

unsigned int testuint6(unsigned int zz61, unsigned int zz62,
                       unsigned int zz63, unsigned int zz64,
                       unsigned int zz65, unsigned int zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test long parameters and long return parameter     */
/*-------------------------------------------------------------------*/
long testlong6(long zz61, long zz62, long zz63, long zz64,
               long zz65, long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned long parameters and                  */
/* unsigned long return parameter                                    */
/*-------------------------------------------------------------------*/
unsigned long testulong6(unsigned long zz61, unsigned long zz62,
                         unsigned long zz63, unsigned long zz64,
                         unsigned long zz65, unsigned long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test long long parameters                          */
/* and long long return parameter                                    */
/*-------------------------------------------------------------------*/
long long testlonglong6(long long zz61, long long zz62,
                        long long zz63, long long zz64,
                        long long zz65, long long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned long long parameters and             */
/* unsigned long long return parameter                               */
/*-------------------------------------------------------------------*/
unsigned long long testulonglong6(unsigned long long zz61,
         unsigned long long zz62, unsigned long long zz63,
         unsigned long long zz64, unsigned long long zz65,
         unsigned long long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test float parameters and float return parameter */
/*-------------------------------------------------------------------*/
float testfloat6( float zz61, float zz62, float zz63,  float zz64,
                     float zz65, float zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test double parameters and double return parameter */
/*-------------------------------------------------------------------*/
double testdouble6( double zz61, double zz62, double zz63,  double zz64,
                     double zz65, double zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test long double parameters and                    */
/* long double return parameter                                      */
/*-------------------------------------------------------------------*/
long double testlongdouble6(long double zz61, long double zz62,
          long double zz63, long double zz64, long double zz65,
          long double zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test var parameter                                 */
/*-------------------------------------------------------------------*/
int testvar3(char zz31, int zz32, ...) {
   va_list ap;
   va_start(ap, zz32);
   va_end(ap);
   return(zz32);
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test char parameters and char return parameter     */
/*-------------------------------------------------------------------*/
void testvoid1(void){
   externalx= 1;
   return;
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test typedef                                       */
/*-------------------------------------------------------------------*/
FREDINT testtypedef(FREDINT zz31, FREDCHAR zz32, FREDLONG zz33) {
   if (zz32 == 'C') return(zz31);
   else return(4);
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test char structures in register and return int    */
/*-------------------------------------------------------------------*/
struct taskret teststructinreg66(struct taskcharparm66 a1,
                                  struct taskcharparm55 a2,
                                  struct taskcharparm44 a3,
                                  struct taskcharparm33 a4,
                                  struct taskcharparm22 a5,
                                  struct taskcharparm11 a6){

   struct taskret xxx66;
   xxx66.x = 15;
   xxx66.a = 'X';

   struct taskret yyy66;
   yyy66.x = 31;
   yyy66.a = 'Y';

   if (a1.j1=='B')
      return(xxx66);
   else
      return(yyy66);
   }


/*-------------------------------------------------------------------*/
/* Function to run C++ function trace test                           */
/*-------------------------------------------------------------------*/
int main(int argc, char **argv) {
   int test_mode = atoi(argv[1]);
   int zero = 0;                 /* for DUMP option (avoid compiler warning) */

   char char1 = 'A';
   char char2 = 'b';
   char char3 = 'C';
   char char4 = 'd';
   char char5 = 'E';
   char char6 = 'f';
   char charreturn = ' ';
   charreturn = testchar6(char1,char2,char3,char4,char5,char6);

   unsigned char uchar1 = 'A';
   unsigned char uchar2 = 'b';
   unsigned char uchar3 = 'C';
   unsigned char uchar4 = 'd';
   unsigned char uchar5 = 'E';
   unsigned char uchar6 = 'f';
   unsigned char ucharreturn = ' ';
   ucharreturn = testuchar6(uchar1,uchar2,uchar3,uchar4,uchar5,uchar6);

   short short1 = 1;
   short short2 = 2;
   short short3 = 3;
   short short4 = 4;
   short short5 = 5;
   short short6 = 6;
   short shortreturn = 0;
   shortreturn = testshort6(short1,short2,short3,short4,short5,short6);

   unsigned short ushort1 = 1;
   unsigned short ushort2 = 2;
   unsigned short ushort3 = 3;
   unsigned short ushort4 = 4;
   unsigned short ushort5 = 5;
   unsigned short ushort6 = 6;
   unsigned short ushortreturn = 0;
   ushortreturn = testushort6(ushort1,ushort2,ushort3,ushort4,ushort5,ushort6);

   int int1 = 1;
   int int2 = 2;
   int int3 = 3;
   int int4 = 4;
   int int5 = 5;
   int int6 = 6;
   int intreturn = 0;
   intreturn = testint6(int1,int2,int3,int4,int5,int6);

   unsigned int uint1 = 1;
   unsigned int uint2 = 2;
   unsigned int uint3 = 3;
   unsigned int uint4 = 4;
   unsigned int uint5 = 5;
   unsigned int uint6 = 6;
   unsigned int uintreturn = 0;
   uintreturn = testuint6(uint1,uint2,uint3,uint4,uint5,uint6);

   long long1 = 1;
   long long2 = 2;
   long long3 = 3;
   long long4 = 4;
   long long5 = 5;
   long long6 = 6;
   long longreturn = 0;
   longreturn = testlong6(long1,long2,long3,long4,long5,long6);

   unsigned long ulong1 = 1;
   unsigned long ulong2 = 2;
   unsigned long ulong3 = 3;
   unsigned long ulong4 = 4;
   unsigned long ulong5 = 5;
   unsigned long ulong6 = 6;
   unsigned long ulongreturn = 0;
   ulongreturn = testulong6(ulong1,ulong2,ulong3,ulong4,ulong5,ulong6);

   long long longlong1 = 1;
   long long longlong2 = 2;
   long long longlong3 = 3;
   long long longlong4 = 4;
   long long longlong5 = 5;
   long long longlong6 = 6;
   long long longlongreturn = 0;
   longlongreturn = testlonglong6(longlong1,longlong2,longlong3,
                       longlong4,longlong5,longlong6);

   unsigned long long ulonglong1 = 1;
   unsigned long long ulonglong2 = 2;
   unsigned long long ulonglong3 = 3;
   unsigned long long ulonglong4 = 4;
   unsigned long long ulonglong5 = 5;
   unsigned long long ulonglong6 = 6;
   unsigned long long ulonglongreturn = 0;
   ulonglongreturn = testulonglong6(ulonglong1,ulonglong2,ulonglong3,
                       ulonglong4,ulonglong5,ulonglong6);

   float  float1 = 1.0;
   float  float2 = 2.0;
   float  float3 = 3.0;
   float  float4 = 4.0;
   float  float5 = 5.0;
   float  float6 = 6.0;
   float  floatreturn = 0.0;
   floatreturn = testfloat6(float1,float2,float3,float4,float5,float6);

   double  double1 = 1.0;
   double  double2 = 2.0;
   double  double3 = 3.0;
   double  double4 = 4.0;
   double  double5 = 5.0;
   double  double6 = 6.0;
   double  doublereturn = 0.0;
   doublereturn = testdouble6(double1,double2,double3,double4,double5,double6);

   long double ld1 = 1.0;
   long double ld2 = 2.0;
   long double ld3 = 3.0;
   long double ld4 = 4.0;
   long double ld5 = 5.0;
   long double ld6 = 6.0;
   long double ldreturn = 0.0;
   ldreturn = testlongdouble6(ld1,ld2,ld3,ld4,ld5,ld6);

   char varchar3 = 'A';
   int varint3 = 3;
   int varret3 = 0;
   varret3 = testvar3(varchar3, varint3);

   free(0);               /* invalid free, but just used to test
                             function trace                          */
   testvoid1();

   int doc_rc = 1555;               /* init to garbage return code   */
   char * fishy_msg;
   fishy_msg = "So long and thanks for all the fish";
   doc_rc = tpf_trace_info(fishy_msg);
   //printf("tpf_trace_info test of doc msg. Return code=%d\n", doc_rc);

   int test80_rc = 1666;            /* init to garbage return code   */
   char * msg_80;
   msg_80 =
"Test tpf_trace_info function with 80-character message...should not be truncated";
   test80_rc = tpf_trace_info(msg_80);
   //printf("tpf_trace_info test of 80-char msg. Return code=%d\n", test80_rc);

   int test81_rc = 1777;            /* init to garbage return code   */
   char * msg_81;
   msg_81 =
"Test tpf_trace_info function, with 81-character message which should be truncated";
   test81_rc = tpf_trace_info(msg_81);
   //printf("tpf_trace info test of 81-char msg. Return code=%d\n", test81_rc);

   int test90_rc = 1888;            /* init to garbage return code   */
   char * msg_90;
   msg_90 =
"Test tpf_trace_info function, with 90-character message which should be truncated by code.";
   test90_rc = tpf_trace_info(msg_90);
   //printf("tpf_trace info test of 90-char msg. Return code=%d\n", test90_rc);

   int test00_rc = 1999;            /* init to garbage return code   */
   char * msg_00;
   msg_00 = "";                  /* contains only the null character */
   test00_rc = tpf_trace_info(msg_00);
   //printf("tpf_trace_info test of 0-char msg. Return code=%d\n", test00_rc);

   FREDINT typedefretint = 0;
   FREDINT typedefint = 3;
   FREDCHAR typedefchar = 0xC1;
   FREDLONG typedeflong = 6;
   typedefretint = testtypedef(typedefint, typedefchar, typedeflong);

   struct taskret structret22;
   structret22.x = 5;
   structret22.a  = 'A';
   struct taskcharparm66 structcharparm66;
   structcharparm66.j1 = 'A';
   structcharparm66.j2 = 'B';
   structcharparm66.j3 = 'C';
   structcharparm66.j4 = 'D';
   structcharparm66.j5 = 'E';
   structcharparm66.j6 = 'F';
   struct taskcharparm55 structcharparm55;
   structcharparm55.j1 = 'G';
   structcharparm55.j2 = 'H';
   structcharparm55.j3 = 'I';
   structcharparm55.j4 = 'J';
   structcharparm55.j5 = 'K';
  struct taskcharparm44 structcharparm44;
   structcharparm44.j1 = 'L';
   structcharparm44.j2 = 'M';
   structcharparm44.j3 = 'N';
   structcharparm44.j4 = 'O';
   struct taskcharparm33 structcharparm33;
   structcharparm33.j1 = 'P';
   structcharparm33.j2 = 'Q';
   structcharparm33.j3 = 'R';
   struct taskcharparm22 structcharparm22;
   structcharparm22.j1 = 'S';
   structcharparm22.j2 = 'T';
   struct taskcharparm11 structcharparm11;
   structcharparm11.j1 = 'U';
   structret22 =  teststructinreg66(structcharparm66, structcharparm55,
                                    structcharparm44, structcharparm33,
                                    structcharparm22, structcharparm11);

   /* Force a dump with a divide by zero                                    */
   if (test_mode == DUMP_YES) {
     test_mode = test_mode / zero;
   }
   else {
      printf("tpf_trace_info test of doc msg. Return code=%d\n", doc_rc);
      printf("tpf_trace_info test of 80-char msg. Return code=%d\n", test80_rc);
      printf("tpf_trace info test of 81-char msg. Return code=%d\n", test81_rc);
      printf("tpf_trace info test of 90-char msg. Return code=%d\n", test90_rc);
      printf("tpf_trace_info test of 0-char msg. Return code=%d\n", test00_rc);
   }

   return 0;
}




