         PRINT NOGEN
         BEGIN NAME=QSB1,IBM=NO,AMODE=64
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSB1                                               *
* DESCRIPTION..... Assembler program, part of QSB1 BSO                *
*                                                                     *
* FUNCTION... 64-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 64-bit assembler program with a       *
*    program base register and no transfer vectors.                   *
*                                                                     *
*    This module contains code for test cases:                        *
*      28, 29, 30, 33, 54, 62, 63                                     *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW                                                  f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC  TEXT='EXECUTING BSO ......, ACN= ..',                  Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW   DS    0H                                                       f5555
         L     R14,EBW000      Test to see which test case this is
         CHI   R14,28          Is it test case 28?
         JE    CASE28          Yes, go do it
         CHI   R14,29          Is it test case 29?
         JE    CASE29          Yes, go do it
         CHI   R14,30          Is it test case 30?
         JE    CASE30          Yes, go do it
         CHI   R14,33          Is it test case 33?
         JE    CASE33          Yes, go do it
         CHI   R14,54          Is it test case 54?
         JE    CASE54          Yes, go do it
         CHI   R14,62          Is it test case 62?
         JE    CASE62          Yes, go do it
         CHI   R14,63          Is it test case 63?
         JE    CASE63          Yes, go do it
         J     CASEERR         Invalid test case number

CASE28   DS    0H
         LMG   R0,R5,CONST28   Load constants into registers
         LA    R6,CONST28      Load the address of the constants
         L     R7,=C'SOLD'     Load the characters 'SOLD' into R7
         ENTRC QSB2            Enter QSB2 (intra-BAL call)
         MVC   EBX000(4),=C'QSB2'  Prep for error routine
         CLM   R7,B'0001',=C'P'  Did case pass?
         JNE   RETERR

         LA    R14,CONST28     Load constant address
         CGR   R6,R14          Is address in R6?
         JNE   RETERR          No, issue error

         CG    R1,CONST28      Is sum in R1?
         JNE   RETERR          No, issue error
         BACKC ,

CASE29   DS    0H
         LMG   R0,R5,CONST29   Load constants into registers
         LA    R6,CONST29      Load the address of the constants
         L     R7,=C'SOLD'     Load the characters 'SOLD' into R7
         ENTRC QSB4            Enter QSB4 (intra-BAL call)
         MVC   EBX000(4),=C'QSB4'  Prep for error routine
         CLM   R0,B'0001',=C'P'  Did case pass?
         JNE   RETERR

         LA    R14,CONST29     Load constant address
         CGR   R5,R14          Is address in R5?
         JNE   RETERR          No, issue error

         CG    R2,CONST29      Is sum in R2?
         JNE   RETERR          No, issue error
         BACKC ,

CASE30   DS    0H
         LMG   R0,R5,CONST30   Load constants into registers
         LA    R6,CONST30      Load address of constants
         L     R7,=C'SOLD'     Load characters 'SOLD' into R7
         ENTRC QSB2            Enter QSB2 (intra-BAL TV)
         MVC   EBX000(4),=C'QSB2'  Prep for error routine
         CLM   R7,B'0001',=C'P'    Did test case pass?
         JNE   RETERR              No, branch to error routine
         BACKC ,

CASE33   DS    0H
         LMG   R0,R5,CONST33   Load constants into registers
         LA    R6,CONST33      Load the address of the constants
         L     R7,=C'SOLD'     Load the characters 'SOLD' into R7
         ENTNC QSB3            Enter QSB3 (intra-BAL TV)
         MVC   EBX000(4),=C'QSB3'  Prep for error routine
         J     UNXPTRET       It should never return here.  Issue error

CASE54   DS    0H
         ENTRC QCE2            Call C entry point function
         BACKC ,

CASE62   DS    0H
CASE63   DS    0H

         LA    R3,TRMESS

         CPROC RETURN=i,tpf_trace_info,(p)
         CALLC tpf_trace_info(R3)  Add a message to the trace table
         ENTRC QCE1
         BACKC ,

EXIT     DS    0H
         EXITC ,

CASEERR  DS    0H
* Bad test case number.  Send error message and exit
         WTOPC TEXT='QSB1: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         J     EXIT                                                     C64CF
         SPACE 1
RETERR   DS    0H
         WTOPC TEXT='QSB1: BAD RETURN VALUE FROM .... FOR TEST CASE ..'X
               ,SUB=(CHARA,EBX000,DECA,EBW000),                        X
               LET=E,NUM=91,PREFIX=SOLD
         J     EXIT                                                     C64CF
         SPACE 1
UNXPTRET DS    0H                                                       C64CF
         WTOPC TEXT='QSB1: UNEXPECTED RETURN FROM QSB3 FOR TEST CASE 33XC64CF
               ',LET=E,NUM=90,PREFIX=SOLD                               C64CF
         J     EXIT                                                     C64CF
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST28  DS  0FD
         DC  FD'100'      All following values must add to this number
         DC  FD'99'
         DC  FD'-10'
         DC  FD'5'
         DC  FD'42'
         DC  FD'-36'
         SPACE 1
CONST29  DS  0FD
         DC  FD'-1'      All following values must add to this number
         DC  FD'-45000000000'
         DC  FD'500'
         DC  FD'45000000600'
         DC  FD'-1300'
         DC  FD'199'
         SPACE 1
CONST30  DS  0FD
         DC  FD'-23900'  All following values must add to this number
         DC  FD'-45000'
         DC  FD'500'
         DC  FD'450600'
         DC  FD'-130000'
         DC  FD'-300000'
         SPACE 1
CONST33  DS  0FD
         DC  FD'0'       All following values must add to this number
         DC  FD'64'
         DC  FD'32'
         DC  FD'-145'
         DC  FD'99'
         DC  FD'-50'
TRMESS   DC  C'Trace Message from QSB1 (TRG_2)'
         SPACE 1
         LTORG
         FINIS
         END
