         PRINT NOGEN
         BEGIN NAME=QSB2,IBM=NO,AMODE=64,TV=QSB3
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSB2                                               *
* DESCRIPTION..... Assembler program, part of QSB1 BSO                *
*                                                                     *
* FUNCTION... 64-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 64-bit assembler program with a       *
*    program base register and one transfer vector (QSB3).            *
*                                                                     *
*    This module contains code for test cases:                        *
*    12,28, 30, 33, 58                                                *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         B     QSB2STRT    Start of TV QSB2
         B     QSB3STRT    Start of TV QSB3
         SPACE 1
QSB2STRT DS    0H
         LGHI  R11,0       Corrupt R11 and R12, they are supposed       C64CF
         LGHI  R12,0         to be usable                               C64CF
         L     R14,EBW000   Load the test case number
         CHI   R14,28       Is it test case 28?
         BE    CASE28       Yes, go do it
         CHI   R14,30       Is it test case 30?
         BE    CASE30       Yes, go do it
         B     CASEERR1     No, branch to error routine

PARMVAL1 DS    0H
         LGR   R14,R1      Test the parameters-load sum into R14
         AGR   R14,R2      Add
         AGR   R14,R3       in
         AGR   R14,R4        remaining
         AGR   R14,R5         registers

         CGR   R0,R14      Is the sum what is expected?
         BNE   PARMERR1    No, issue error
         CG    R0,0(R6)    Does the address in R6 point to the sum?
         BNE   PARMERR1    No, issue error
         CL    R7,=C'SOLD' Does R7 contain the driver name?
         BNE   PARMERR1    No, issue error
         BR    R15
         SPACE 1

CASE28   DS    0H
CASE30   DS    0H
         BAS   R15,PARMVAL1 Check parameters
         ENTRC QSB6         Inter module TV
         BACKC ,

CASEERR1 DS    0H
* Bad test case.  Send error message and exit.
         WTOPC TEXT='QSB2: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC
         SPACE 1
PARMERR1 DS    0H
* Bad parameters passed.  Send error message and exit.
         WTOPC TEXT='QSB3: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE 1
***********************************************************************
QSB3STRT DS    0H
         L     R14,EBW000   Load the test case number
         CHI   R14,33       Is it test case 33?
         BE    CASE33       Yes, go do it
         CHI   R14,58       Is it test case 58?
         BE    CASE58       Yes, go do it
         B     CASEERR2     No, branch to error routine

PARMVAL2 DS    0H
         LGR   R14,R1      Load the first value into R14
         AGR   R14,R2      Add
         AGR   R14,R3        in
         AGR   R14,R4         remaining
         AGR   R14,R5          registers

         CGR   R0,R14      Is the sum what is expected?
         BNE   PARMERR2    No, issue error
         CG    R0,0(R6)    Does the address in R6 point to the sum?
         BNE   PARMERR2    No, issue error
         CL    R7,=C'SOLD' Does R7 contain the driver name?
         BNE   PARMERR2    No, issue error
         BR    R15

CASE33   DS    0H
         BAS   R15,PARMVAL2 Check parameters
         ENTNC QSB6        Inter-BAL TV
         B     UNXPTRET    This test case does not return.
*                          Issue error if it does.

CASE58   DS    0H
         BAS   R15,PARMVAL2 Check parameters
* Prepare for CALLC
         CPROC RETURN=c,qsc3a,(c,c,c,c,c,c,p)
         XGR   R0,R0       Zero out register
         LLILL R0,C'A'     Add parameter
         XGR   R1,R1       Zero out register
         LLILL R1,C'B'     Add parameter
         XGR   R2,R2       etc
         LLILL R2,C'C'        etc
         XGR   R3,R3             etc
         LLILL R3,C'D'
         XGR   R4,R4
         LLILL R4,C'E'
         XGR   R5,R5
         LLILL R5,C'F'
         XGR   R6,R6       Zero out register
         LA    R6,CONST58  Add pointer parameter
* Make function call
         CALLC qsc3a(R0,R1,R2,R3,R4,R5,R6)
         MVC   EBX000(4),=C'QSB2'  Prep for error routine
         LA    R2,=C'QSC3' SET WTOPC PROG NAME PARM                     d10796
         CHI   R15,C'P'    Check results                                d10796
         BNE   RETERR      If not as expected, branch to error
         BACKC ,

CASEERR2 DS    0H
* Bad test case.  Send error message and exit.
         WTOPC TEXT='QSB3: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC
         SPACE 1
PARMERR2 DS    0H
* Bad parameters passed.  Send error message and exit
         WTOPC TEXT='QSB3: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE 1
UNXPTRET DS    0H
* Test case should not return
         WTOPC TEXT='QSB3: UNEXPECTED RETURN FROM QSB6 FOR TEST CASE 33XC64CF
               ',LET=E,NUM=90,PREFIX=SOLD                               C64CF
         EXITC ,
         SPACE 1
RETERR   DS    0H
* Bad return value.  Send error message and exit.
         WTOPC TEXT='QSB2: BAD RETURN VALUE FROM .... FOR TEST CASE ..'X
               ,SUB=(CHARA,(R2),DECA,EBW000),                          X
               LET=E,NUM=91,PREFIX=SOLD
         EXITC ,
         SPACE 1
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST58  DS  0F
         DC  C'ABCDEF'
         SPACE 1
         LTORG  ,
         FINIS  ,
         END    ,
