         PRINT NOGEN
         BEGIN NAME=QSB5,IBM=NO,AMODE=64,TV=(QSBZ,QSB6)
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSB5                                               *
* DESCRIPTION..... Assembler program, part of QSB5 BSO                *
*                                                                     *
* FUNCTION... 64-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 64-bit assembler program with a       *
*    program base register and two transfer vectors (QSBZ, QSB6)      *
*                                                                     *
*    This module contains code for test cases:                        *
*      28, 29, 30, 31, 33, 52, 53, 54, 57, 62, 63                     *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         B     QSB5STRT    Start of TV QSB5
         B     QSBZSTRT    Start of TV QSBZ
         B     QSB6STRT    Start of TV QSB6
         SPACE 1
QSB5STRT DS    0H
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW                                                  f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW   DS    0H
         L     R14,EBW000  Load test case
         CHI   R14,31      Is it test case 31?
         JE    CASE31      Yes, go do it
         CHI   R14,62      Is it test case 62?
         JE    CASE62      Yes, go do it
         CHI   R14,63      Is it test case 63?
         JE    CASE63      Yes, go do it
         J     CASEERR1

CASE31   DS    0H
         LMG   R0,R6,CONST31      Load parameters for function call
         ENTRC QSBC               Enter QSBC (31-bit inter-BAL)
         MVC   EBX000(4),=C'QSBC' Prep for error routine
         CLM   R7,B'0001',=C'P'   Did case pass?
         JNE   RETERR1            No, issue error
         BACKC

CASE62   DS    0H

         LA    R3,TRMESS

         CPROC RETURN=i,tpf_trace_info,(p)
         CALLC tpf_trace_info(R3) Add a message to the trace table
         BACKC ,

CASE63   DS    0H

         LA    R3,TRMESS

         CPROC RETURN=i,tpf_trace_info,(p)
         CALLC tpf_trace_info(R3) Add a message to the trace table
         ENTRC QCE2
         BACKC ,

CASEERR1 DS    0H
* Bad test case.  Send error message and exit.
         WTOPC TEXT='QSB5: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC
         SPACE 1

RETERR1  DS    0H
* Bad return value.  Send error message and exit.
         WTOPC TEXT='QSB5: BAD RETURN VALUE FROM .... FOR TEST CASE ..'X
               ,SUB=(CHARA,(R2),DECA,EBW000),                          X
               LET=E,NUM=91,PREFIX=SOLD
         EXITC ,
         SPACE
***********************************************************************
QSBZSTRT DS    0H
* QSBZ is a dummy transfer vector so that there are multiple transfer
* vectors in this module.  Always issue an error if we go here
         WTOPC TEXT='QSBZ: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC
         SPACE 1
***********************************************************************
QSB6STRT DS    0H
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW1                                                 f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW1  DS    0H
         L     R14,EBW000   Load the test case number
         CHI   R14,28
         JE    CASE28       Go to test case 28
         CHI   R14,29
         JE    CASE29       Go to test case 29
         CHI   R14,30
         JE    CASE30       Go to test case 30
         CHI   R14,33
         JE    CASE33       Go to test case 33
         CHI   R14,52
         JE    CASE52       Go to test case 52
         CHI   R14,53
         JE    CASE53       Go to test case 53
         CHI   R14,54
         JE    CASE54       Go to test case 54
         CHI   R14,57
         JE    CASE57       Go to test case 57
         J     CASEERR2     Invalid test case number

PARMVAL2 DS    0H
         LGR   R14,R1       Load the first value into R14
         AGR   R14,R2       Add
         AGR   R14,R3         in
         AGR   R14,R4          remaining
         AGR   R14,R5           registers

         CGR   R0,R14      Is the sum what is expected?
         JNE   PARMERR2    No, issue error
         CG    R0,0(R6)    Does the address in R6 point to the sum?
         JNE   PARMERR2    No, issue error
         BR    R15

CASE28   DS    0H
         JAS   R15,PARMVAL2 Check parameters
         ENTRC QSB9         inter module, baseless
         J     RETURN

CASE29   DS    0H
         JAS   R15,PARMVAL2 Check parameters
         ENTRC QSB8         inter module
         LR    R0,R7        Move return value to R0
* The above is temporary until LREGSC can be used.
* The return path has R7 as a base reg and the return
* value would be lost otherwise.
         J     RETURN

CASE30   DS    0H
CASE52   DS    0H
         JAS   R15,PARMVAL2 Check parameters
         XGR   R7,R7        Zero out register
         LLILL R7,C'P'      Test case passed
         J     RETURN       End of the line. Go back.

CASE33   DS    0H
         JAS   R15,PARMVAL2      Check parameters
         CLI   EBW008,1          Is this continuous mode?
         JE    CASE33A           Yes, don't issue message
         WTOPC TEXT='TEST CASE 33 HAS COMPLETED',                      X
               LET=I,NUM=4,PREFIX=SOLD
CASE33A  DS    0H
* This test case does not return.  It simply exits.
         EXITC ,
         SPACE 1

CASE53   DS    0H
CASE54   DS    0H
CASE57   DS    0H
         JAS   R15,PARMVAL2      Check parameters
         ENTRC QCE3              Call C entry
         LGR   R7,R0             Load sum into R7
         J     RETURN

RETURN   DS    0H
         BACKC ,

CASEERR2 DS    0H
* Bad test case.  Send error message and exit.
         WTOPC TEXT='QSB6: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
         SPACE 1
PARMERR2 DS    0H
* Bad parameters passed.  Send error message and exit.
         WTOPC TEXT='QSB6: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC ,
         SPACE 1
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST31  DS  0FD
         DC  FD'62199'
         DC  FD'-62199'
         DC  FD'-7528'    all 7 values must add up to 0
         DC  FD'7528'
         DC  FD'-51802'
         DC  FD'49921'
         DC  FD'1881'
TRMESS   DC  C'Trace Message from QSB5 (TRG_4)'
         SPACE 1
         LTORG  ,
         FINIS  ,
         END    ,
