         PRINT NOGEN
         BEGIN NAME=QSB7,IBM=NO,AMODE=64,BASE=NONE
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSB7                                               *
* DESCRIPTION..... Assembler program, part of QSBA BSO                *
*                                                                     *
* FUNCTION... 31-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 64-bit assembler program with         *
*    no base registers and no transfer vectors.                       *
*                                                                     *
*    This module contains code for test cases:                        *
*      31, 55                                                         *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         L     R14,EBW000      Test to see which test case this is
         CHI   R14,31          Is it test case 31?
         JE    CASE31          Yes, go do it
         CHI   R14,55          Is it test case 55?
         JE    CASE55          Yes, go do it
         J     CASEERR         Invalid test case number

CASE31   DS    0H
         JAS   R15,PARMVAL     Check validity of parameters
         LARL  R14,CONST31     Load
         LMG   R0,R6,0(R14)        Parameters
         ENTRC QSBF            Enter QSBF
         BACKC ,               Return to caller

CASE55   DS    0H
         JAS   R15,PARMVAL     Check validity of parameters
         ENTRC QCE3            Enter C entry QCE3
         XGR   R7,R7           Zero out register
         LLILL R7,C'P'         Test case passed
         BACKC ,

PARMVAL  DS    0H
         LR    R14,R1          Add
         AR    R14,R2           register
         AR    R14,R3            values
         AR    R14,R4
         AR    R14,R5
         AR    R14,R6
         CR    R0,R14          Compare sum to value in r0
         JNE   PARMERR         If the sum isn't good, throw error
         BR    R15

PARMERR  DS    0H
* Bad parameters. Issue error message and exit
         WTOPC TEXT='QSB7: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC ,
         SPACE

CASEERR  DS    0H
* Bad case number. Issue error and exit
         WTOPC TEXT='QSB7: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST31  DS  0FD
         DC  FD'449999499'   values must add to this number
         DC  FD'0'
         DC  FD'0'
         DC  FD'0'
         DC  FD'450000600'
         DC  FD'-1300'
         DC  FD'199'
         SPACE 1
         LTORG
         FINIS
         END
