         PRINT NOGEN
         BEGIN NAME=QSB8,IBM=NO,AMODE=64
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSB8                                               *
* DESCRIPTION..... Assembler program, part of QSB8 BSO                *
*                                                                     *
* FUNCTION... 64-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 64-bit assembler program with a       *
*    program base register and no transfer vectors.                   *
*                                                                     *
*    This module contains code for test cases:                        *
*      29, 31, 51, 56                                                 *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW                                                  f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW   DS    0H                                                       f5555
         L     R14,EBW000  Load the test case number
         CHI   R14,29      Is it test case 29?
         JE    CASE29      Yes, go do it
         CHI   R14,31      Is it test case 31?
         JE    CASE31      Yes, go do it
         CHI   R14,51      Is it test case 51?
         JE    CASE51      Yes, go do it
         CHI   R14,56      Is it test case 56?
         JE    CASE56      Yes, go do it
         J     CASEERR     No, issue error

PARMVAL  LGR   R14,R1      Load the first value into R14
         AGR   R14,R2      Add
         AGR   R14,R3        in
         AGR   R14,R4         remaining
         AGR   R14,R5          registers

         CGR   R0,R14      Is the sum what is expected?
         JNE   PARMERR     No, issue error
         CG    R0,0(R6)    Does the address in R6 point to the sum?
         JNE   PARMERR     No, issue error
         CL    R7,=C'SOLD' Does R7 contain the driver name?
         JNE   PARMERR     No, issue error
         BR    R15
         SPACE 1

CASE29   DS    0H
CASE56   DS    0H
         JAS   R15,PARMVAL Check parameters
         XGR   R7,R7       Zero out register
         LLILL R7,C'P'     Test case passed
         LGR   R5,R6       Put constant address in R5
         LGR   R2,R0       Put sum in R2
         J     RETURN      Return to the caller

CASE31   DS    0H
         XGR   R7,R7       Zero out register
         LLILL R7,C'P'     Test case passed
         J     RETURN

CASE51   DS    0H
         JAS   R15,PARMVAL Check parameters
         ENTRC QCE2        Enter QCE2 (C entry)
         XGR   R7,R7       Zero out register
         LLILL R7,C'P'     Test case passed
         J     RETURN

RETURN   DS    0H
         BACKC ,

CASEERR  DS    0H
* Bad test case number.  Send error message and exit
         WTOPC TEXT='QSB8: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
PARMERR  DS    0H
* Bad parameters sent.  Send error message and exit.
         WTOPC TEXT='QSB8: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
         LTORG
         FINIS
         END
