         PRINT NOGEN
         BEGIN NAME=QSB9,IBM=NO,AMODE=64,BASE=NONE
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSB9                                               *
* DESCRIPTION..... Assembler program, part of QSB8 BSO                *
*                                                                     *
* FUNCTION... 64-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 64-bit assembler program with no      *
*    program base register and no transfer vectors.                   *
*                                                                     *
*    This module contains code for test cases:                        *
*      28, 59                                                         *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         LGHI  R11,-11     Corrupt R11 and R12 since we are             C64CF
         LGHI  R12,-12       supposed to be able to use them            C64CF
         LGHI  R8,-1       Put -1 into what is normally the base reg
         L     R14,EBW000  Load the test case number
         CHI   R14,28      Is it test case 28?
         JE    CASE28      Yes, go do it
         CHI   R14,59      Is it test case 59?
         JE    CASE59      Yes, go do it
         CHI   R14,12      Is it test case 12?                          C64CF
         JE    CASE12      Yes, go do it                                C64CF
         J     CASEERR     No, issue error

PARMVAL  DS    0H
         LGR   R14,R1      Load the first value into R14
         AGR   R14,R2      Add
         AGR   R14,R3        in
         AGR   R14,R4         remaining
         AGR   R14,R5          registers

         CGR   R0,R14      Is the sum what is expected?
         JNE   PARMERR     No, issue error
         CG    R0,0(R6)    Does the address in R6 point to the sum?
         JNE   PARMERR     No, issue error
         LARL  R14,=C'SOLD' Load the constant to compare against
         CL    R7,0(R14)   Does R7 contain the driver name?
         JNE   PARMERR     No, issue error
         BR    R15
         SPACE 1

CASE12   DS    0H                                                       C64CF
CASE28   DS    0H
CASE59   DS    0H
         JAS   R15,PARMVAL Check parameters
         XGR   R7,R7       Zero out register
         LLILL R7,C'P'     Test case passed
         LGR   R1,R0       Put sum in R1
         BACKC ,

CASEERR  DS    0H
* Bad test case number.  Send error message and exit
         WTOPC TEXT='QSB9: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
PARMERR  DS    0H
* Bad parameters passed.  Send error message and exit
         WTOPC TEXT='QSB9: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
         LTORG
         FINIS
         END
