         PRINT NOGEN
         BEGIN NAME=QSBA,IBM=NO,AMODE=31
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSBA                                               *
* DESCRIPTION..... Assembler program, part of QSBA BSO                *
*                                                                     *
* FUNCTION... 31-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 31-bit assembler program with a       *
*    program base register and no transfer vectors.                   *
*                                                                     *
*    This module contains code for test cases:                        *
*    12,26, 27, 53                                                    *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW                                                  f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R1,CE3PATG(R12,R9)                                      f12472
         IDSPAT REG=R1                                                  f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW   DS    0H                                                       f5555
         L     R1,EBW000       Test to see which test case this is
         CHI   R1,26           Is it test case 26?
         BE    CASE26          Yes, go do it
         CHI   R1,27           Is it test case 27?
         BE    CASE27          Yes, go do it
         CHI   R1,53           Is it test case 53?
         BE    CASE53          Yes, go do it
         CHI   R1,12           Is it test case 12?
         BE    CASE12          Yes, go do it
         B     CASEERR         Invalid test case number

CASE12   DS    0H
         LGHI  R11,-1          Corrupt R11 and R12 - should be able     C64CF
         LGHI  R12,-2           to use them for anything                C64CF
         CLI   EBW008,1          Is this continuous mode?               C64CF
         BE    CASE12A           Yes, don't issue message               C64CF
         WTOPC TEXT='ENTRC TO ASM WITH NULL PARM SUCCESSFUL'
CASE12A  DS    0H                                                       C64CF
         BACKC ,

CASE26   DS    0H
         LM    R0,R5,CONST26   Load constants into registers
         LA    R6,CONST26      Load the address of the constants
         ENTRC QSBB            Enter QSBB (intra-BAL call)
         LA    R2,=C'QSBB'     Prep for error routine
         CLM   R0,B'0001',=C'P'  Did case pass?
         BNE   RETERR          No, issue error
         BACKC ,

CASE27   DS    0H
         LM    R0,R5,CONST27   Load constants into registers
         LA    R6,CONST27      Load the address of the constants
         L     R7,=C'SOLD'     Load the characters 'SOLD' into R7
         ENTRC QSBB            Enter QSBB (intra-BAL call)
         LA    R2,=C'QSBB'     Prep for error routine
         CLM   R7,B'0001',=C'P'  Did case pass?
         BNE   RETERR          No, issue error

         LA    R14,CONST27     Load constant address
         CR    R4,R14          Is address in R4?
         BNE   RETERR          No, issue error

         C     R3,CONST27      Is sum in R3?
         BNE   RETERR          No, issue error
         BACKC ,               Return to caller

CASE53   DS    0H
         ENTRC QCE2
         BACKC ,

CASEERR  DS    0H
* Bad test case number.  Send error message and exit
         WTOPC TEXT='QSBA: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
         SPACE
RETERR   DS    0H
* Bad return value. Send error message and exit
         WTOPC TEXT='QSBA: BAD RETURN VALUE FROM .... FOR TEST CASE ..'X
               ,SUB=(CHARA,(R2),DECA,EBW000),                          X
               LET=E,NUM=91,PREFIX=SOLD
         EXITC ,
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST27  DS  0F
         DC  F'205'      All following values must add to this number
         DC  F'12'
         DC  F'-20000000'
         DC  F'5'
         DC  F'19999993'
         DC  F'195'
         SPACE 1
CONST26  DS  0F
         DC  F'100161'   All following values must add to this number
         DC  F'1028'
         DC  F'-101880'
         DC  F'282003'
         DC  F'-81603'
         DC  F'613'
         SPACE 1
         LTORG
         FINIS
         END
