         PRINT NOGEN
         BEGIN NAME=QSBC,IBM=NO,AMODE=31,TV=QSBD
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSBC                                               *
* DESCRIPTION..... Assembler program, part of QSBC BSO                *
*                                                                     *
* FUNCTION... 31-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 31-bit assembler program with a       *
*    program base register and one transfer vector (QSBD).            *
*                                                                     *
*    This module contains code for test cases:                        *
*      26, 27, 30, 31, 32, 51, 53, 54                                 *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         B     QSBCSTRT    Start of TV QSB2
         B     QSBDSTRT    Start of TV QSB3
         SPACE 1

QSBCSTRT DS    0H
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW                                                  f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW   DS    0H                                                       f5555
         L     R14,EBW000   Load the test case number
         CHI   R14,26       Case 26?
         JE    CASE26       Yes, do it
         CHI   R14,30       Case 30?
         JE    CASE30       Yes, do it
         CHI   R14,31       Case 31?
         JE    CASE31       Yes, do it
         CHI   R14,32       Case 32?
         JE    CASE32       Yes, do it
         CHI   R14,51       Case 51?
         JE    CASE51       Yes, do it
         J     CASEERR1     No, branch to error routine

PARMVAL1 DS    0H
         LR    R14,R0       Add
         AR    R14,R1          parameters
         AR    R14,R2             together
         AR    R14,R3
         AR    R14,R4
         AR    R14,R5
         AR    R14,R6
         JNZ   PARMERR1     If they don't add to 0 issue error
         BR    R15

CASE26   DS    0H
CASE51   DS    0H
         JAS   R15,PARMVAL1 Check parameters
         XGR   R7,R7        Zero out register
         LLILL R7,C'P'      Test case passed
         BACKC

CASE30   DS    0H
         ENTRC QSB1               Enter QSB1
         MVC   EBX000(4),=C'QSB1' Prep for error routine
         CLM   R7,B'0001',=C'P'   Check to see if case passed
         JNE   RETERR1            No, branch to error routine
         BACKC ,

CASE31   DS    0H
         JAS   R15,PARMVAL1       Check parameters
         LR    R0,R1              Setting up param for next module
         ENTRC QSB7               Enter QSB7
         MVC   EBX000(4),=C'QSB7' Prep for error routine
         CLM   R7,B'0001',=C'P'   Check to see if case passed
         JNE   RETERR1            No, branch to error routine
         BACKC

CASE32   DS    0H
         JAS   R15,PARMVAL1       Check parameters
         CLI   EBW008,1           Is this continuous mode?
         JE    CASE32A            Yes, don't issue message
         WTOPC TEXT='TEST CASE 32 HAS COMPLETED',                      X
               LET=I,NUM=4,PREFIX=SOLD
CASE32A  DS    0H
* This test case does not return.  It simply exits.
         EXITC ,

CASEERR1 DS    0H
* Bad case number. Issue error and exit
         WTOPC TEXT='QSBC: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC
         SPACE 1

RETERR1  DS    0H
* Bad return value. Issue error and exit
         WTOPC TEXT='QSB1: BAD RETURN VALUE FROM .... FOR TEST CASE ..'X
               ,SUB=(CHARA,EBX000,DECA,EBW000),                        X
               LET=E,NUM=91,PREFIX=SOLD
         EXITC
         SPACE 1

PARMERR1 DS    0H
* Bad parameters passed. Issue error and exit
         WTOPC TEXT='QSBC: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE 1
***********************************************************************
QSBDSTRT DS    0H
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW1                                                 f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW1  DS    0H
         L     R14,EBW000   Load the test case number
         CHI   R14,27       Is it test case 27?
         JE    CASE27       Yes, go do it
         CHI   R14,32       Is it test case 27?
         JE    CASE32D      Yes, go do it
         CHI   R14,53       Is it test case 27?
         JE    CASE53       Yes, go do it
         CHI   R14,54       Is it test case 27?
         JE    CASE54       Yes, go do it
         J     CASEERR2

PARMVAL2 LR    R14,R1      Load the first value into R14
         AR    R14,R2      Add
         AR    R14,R3        in
         AR    R14,R4         remaining
         AR    R14,R5          registers

         CR    R0,R14      Is the sum what is expected?
         JNE   PARMERR2    No, issue error
         CL    R7,=C'SOLD' Does R7 contain the driver name?
         JNE   PARMERR2    No, issue error
         BR    R15

CASE27   DS    0H
         JAS   R15,PARMVAL2  Check parameters
         C     R0,0(R6)      Does the address in R6 point to the sum?
         JNE   PARMERR2      No, issue error
         XGR   R7,R7         Zero out register
         LLILL R7,C'P'       Test case passed
         LR    R4,R6         Put constant address in R4
         LR    R3,R0         Put sum in R3
         BACKC ,

CASE32D  DS    0H
         JAS   R15,PARMVAL2  Check parameters
         C     R0,0(R6)      Does the address in R6 point to the sum?
         JNE   PARMERR2      No, issue error
         LM    R0,R6,CONST32 Load parameters for next call
         ENTNC QSBC          Enter QSBC
         J     UNXPTRET      Test case should not return

CASE53   DS    0H
CASE54   DS    0H
         JAS   R15,PARMVAL2  Check parameters
         C     R0,4(R6)      Does the address in R6 point to the sum?
         JNE   PARMERR2      No, issue error
         XGR   R7,R7         Zero out register
         LLILL R7,C'P'       Test case passed
         BACKC ,

CASEERR2 DS    0H
* Bad test case. Issue error and exit
         WTOPC TEXT='QSBD: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC
         SPACE 1

PARMERR2 DS    0H
* Bad parameters passed. Issue error and exit
         WTOPC TEXT='QSBD: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE 1

UNXPTRET DS    0H
* Test case should not return. Issue error and exit
         WTOPC TEXT='QSBD: UNEXPECTED RETURN FROM QSBC FOR TEST CASE 32XC64CF
               ',LET=E,NUM=90,PREFIX=SOLD                               C64CF
         EXITC ,
         SPACE 1
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST32  DS  0F
         DC  F'-12'      All following values must add to zero
         DC  F'12'
         DC  F'-20000000'
         DC  F'20000000'
         DC  F'19999993'
         DC  F'-195'
         DC  F'-19999798'
         SPACE 1
         LTORG  ,
         FINIS  ,
         END    ,
