         PRINT NOGEN
         BEGIN NAME=QSBE,IBM=NO,AMODE=31
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  f4692    09/10/04     Add test cases 15, 17,19       NWang         *
*                        for Loader Dynamic Linkage                   *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSBE                                               *
* DESCRIPTION..... Assembler program, part of QSBE BSO                *
*                                                                     *
* FUNCTION... 31-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 31-bit assembler program with a       *
*    program base register and no transfer vectors.                   *
*                                                                     *
*    This module contains code for test cases:                        *
*    12, 15, 17, 19, 27, 32, 60                                       *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE                                               *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW                                                  f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW   DS    0H                                                       f5555
SAVE_PBI EQU   EBW090,2
         SPACE
         LGHI  R11,-1      Corrupt R11 and R12 since they are supposed
         LGHI  R12,-2        to be usable
         L     R14,EBW000  Load the test case number
         CHI   R14,27      Is it test case 27?
         BE    CASE27      Yes, go do it.
         CHI   R14,32      Case 32?
         BE    CASE32      Do it.
         CHI   R14,34      Case 34?
         BE    CASE34      Do it.
         CHI   R14,60      Case 60?
         BE    CASE60      Do it.
         CHI   R14,12      Case 12?                                     C64CF
         BE    CASE12      Do it.                                       C64CF
         CHI   R14,15      Case 15?                                     f4692
         BE    CASE15      Do it.                                       f4692
         CHI   R14,17      Case 17?                                     f4692
         BE    CASE17      Do it.                                       f4692
         CHI   R14,19      Case 19?                                     f4692
         BE    CASE19      Do it.                                       f4692
         B     CASEERR     No, issue error

PARMVAL  DS    0H
         LR    R14,R1      Load the first value into R14
         AR    R14,R2      Add
         AR    R14,R3        in
         AR    R14,R4         remaining
         AR    R14,R5          registers

         CR    R0,R14      Is the sum what is expected?
         BNE   PARMERR     No, issue error
         C     R0,0(R6)    Does the address in R6 point to the sum?
         BNE   PARMERR     No, issue error
         CL    R7,=C'SOLD' Does R7 contain the driver name?
         BNE   PARMERR     No, issue error
         BR    R15
         SPACE 1
CASE27   DS    0H
         BAS   R15,PARMVAL Check parameters
         ENTRC QSBD        Enter 31-bit BAL
         LR    R0,R7       Move return value into R0
* Temporary move until LREGSC can be used
         BACKC ,           Return to the caller
         SPACE 1

CASE32   DS    0H
         LM    R0,R5,CONST32   Load constants into registers
         LA    R6,CONST32      Load the address of the constants
         L     R7,=C'SOLD'     Load the characters 'SOLD' into R7
         ENTDC QSBD            Enter 31-bit BAL
         J     UNXPTRET        This case shouldn't return
         SPACE 1
CASE34   DS    0H
         MS0UT REG=R6
         XR    R6,R6
         ICM   R6,B'0011',CE1PBI
         UATBC IDLOC=(R,SSI,R6),EXCD=SS_ERROR,INVLID=SS_ERROR,         X
               NOTAVL=SS_ERROR
         CLI   EBW008,1                   CONTINUOUS MODE?
         BZ    SKIPMSG_34A
         WTOPC TEXT='QSBE: CURRENT SS .... ',                          X
               SUB=(CHARA,MU0NAM),                                     X
               NUM=91,PREFIX=SOLD
SKIPMSG_34A    DS   0H
         XR    R6,R6          Clear work register
         ST    R6,EBW092      Save SS number for loop
         MVC   SAVE_PBI,CE1PBI SAVE PBI
         MVI   EBCM01,C'A'
SSLOOP   DS    0H
         L     R6,EBW092      Pick up current SS number
         LA    R6,1(R6)       Increment
         ST    R6,EBW092      Save it again
***********************************************************************
* For the SS whose ordinal number is in R6                            *
*    Get the address of the SSUT entry of the first SSU.              *
* If the SS ordinal number is invalid or not available                *
*    then try the next SS ordinal number                              *
* If the SS ordinal number exceeds maximum                            *
*    then CROSC to BSS                                                *
***********************************************************************
         UATBC IDLOC=(R,SSI,R6),EXCD=NOTAVAIL,INVLID=SSLOOP,           X
               NOTAVL=SSLOOP
*        CLC   MU0NAM(2),=C'WP'    Is this a WP system?
*        JNE   SSLOOP              No, continue to the next SS
         CLC   SAVE_PBI,MU0DPI     SAME PBI ?
         JE    SSLOOP              YES, TRY another one
         LM    R0,R5,CONST32       Load constants into registers
         CLI   EBW008,1                   CONTINUOUS MODE?
         BZ    SKIPMSG_34B
         WTOPC TEXT='QSBE: CROSC TO .... ',                            X
               SUB=(CHARA,MU0NAM),                                     X
               NUM=95,PREFIX=SOLD
SKIPMSG_34B    DS   0H
         ICM   R6,B'1100',MU0DPI   MOVE DPI to TOP OF R6
         SRL   R6,16               SHIFT R6 BY 2 BYTES, CLEAR JUNK
         PRINT GEN
         CROSC ENTRC,PROGRAM=QSWP,INVAL=NOTAVAIL,IDLOC=R6
         PRINT NOGEN
         J     CHKRET              Check return value
         SPACE 1
NOTAVAIL DS    0H
         CLI   EBW008,1                   CONTINUOUS MODE?
         BZ    SKIPMSG_34C
         WTOPC TEXT='QSBE: CROSC TO BSS ',                             X
               NUM=95,PREFIX=SOLD
SKIPMSG_34C    DS   0H
         LM    R0,R5,CONST32       Load constants into registers
         CROSC ENTRC,PROGRAM=QSWP,IDLOC=BSS
         J     CHKRET
         SPACE 1
CHKRET   DS    0H
         LA    R2,=C'QSWP'        SET WTOPC PROG NAME PARM
         CR    R0,R7              Does the value in R7 match the sum?
         JNE   RETERR             No, issue error

         CLC   CE1PBI,SAVE_PBI    Did PBI get restored correctly
         JNE   PBIERR
         CLI   EBW008,1                   CONTINUOUS MODE?
         BZ    SKIPMSG_34E
         WTOPC TEXT='QSBE: PBI RESTORE VALIDATED',                     X
               NUM=96,PREFIX=SOLD
SKIPMSG_34E    DS   0H
         XR    R6,R6
         ICM   R6,B'0011',CE1PBI  MOVE DPI to TOP OF R6
         CROSC ENTRC,PROGRAM=QSWP,INVAL=NOTAVAIL,IDLOC=R6
         CLI   EBW008,1                   CONTINUOUS MODE?
         BZ    SKIPMSG_34D
         WTOPC TEXT='QSBE: CROSC TO SELF TO RESET DBI/SSU',            X
               NUM=96,PREFIX=SOLD
SKIPMSG_34D    DS   0H
         BACKC ,
         SPACE 1

CASE15   DS    0H                                                       f4692
         WTOPC TEXT='QSBE: BSO ENTRC QQQQ, SHOULD GET DUMP',           Xf4692
               NUM=01,PREFIX=QSBE                                       f4692
         ENTRC QQQQ                                                     f4692
         WTOPC TEXT='QSBE: FAILED GETTING DUMP',                       Xf4692
               NUM=02,PREFIX=QSBE                                       f4692
         EXITC                                                          f4692
         SPACE 1                                                        f4692
CASE17   DS    0H                                                       f4692
         WTOPC TEXT='QSBE: BSO ENTRC DATA PROG BXAX, SHOULD GET DUMP', Xf4692
               NUM=01,PREFIX=QSBE                                       f4692
         ENTRC BXAX                                                     f4692
         WTOPC TEXT='QSBE: FAILED GETTING DUMP',                       Xf4692
               NUM=02,PREFIX=QSBE                                       f4692
         EXITC                                                          f4692
         SPACE 1                                                        f4692
CASE19   DS    0H                                                       f4692
         WTOPC TEXT='QSBE: BSO ENTRC GTAL, SHOULD GET DUMP',           Xf4692
               NUM=01,PREFIX=QSBE                                       f4692
         ENTRC GTAL                                                     f4692
         WTOPC TEXT='QSBE: FAILED GETTING DUMP',                       Xf4692
               NUM=02,PREFIX=QSBE                                       f4692
         EXITC                                                          f4692
         SPACE 1                                                        f4692

CASE12   DS    0H                                                       C64CF
CASE60   DS    0H
* Check input parameters
         BAS   R15,PARMVAL

* Prepare for CALLC
         CPROC RETURN=i,qsc3b,(i,i,i,i,i,i,p)
         LGHI  R1,621              Load
         LGHI  R2,-5324                Parameters
         LGHI  R3,5                Making sure
         LGHI  R4,16547                top of
         LGHI  R5,5148                     registers
         LGHI  R6,-5823                        are zeroed
         LGHI  R0,0                Zero out register
         LA    R0,SUM60            Load pointer to pass
* Make function call
         CALLC qsc3b(R1,R2,R3,R4,R5,R6,R0)
         MVC   EBX000(4),=C'QSC3'  Prep for error routine
         LA    R2,=C'QSC3'         SET WTOPC PROG NAME PARM             d10793
         CHI   R15,1               Check return value                   d10796
         BNE   RETERR
         LGHI  R0,-1               Corrupt upper part of regs
         LGHI  R1,0                Corrupt upper part of regs
         LGHI  R2,-1               Corrupt upper part of regs
         LGHI  R3,-1               Corrupt upper part of regs
         LGHI  R4,-1               Corrupt upper part of regs
         LGHI  R5,0                Corrupt upper part of regs
         LGHI  R6,-1               Corrupt upper part of regs
         LGHI  R7,-1               Corrupt upper part of regs
         LM    R0,R7,CASE60RET     Load lower part for return
         BACKC ,
         SPACE 1

SS_ERROR DS    0H
* Error determining current SS
         WTOPC TEXT='QSBE: UNKNOWN SUBSYSTEM',                         X
               LET=E,NUM=95,PREFIX=SOLD
         EXITC ,

CASEERR  DS    0H
* Bad test case number.  Send error message and exit
         WTOPC TEXT='QSBE: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
PARMERR  DS    0H
* Bad parameters. Send error message and exit
         WTOPC TEXT='QSBE: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE
UNXPTRET DS    0H
* Test case should not have returned.  Send error message and exit
         WTOPC TEXT='QSBE: UNEXPECTED RETURN FROM QSBD FOR TEST CASE 32X
               ',LET=E,NUM=90,PREFIX=SOLD
         EXITC
         SPACE
PBIERR   DS    0H
* Bad PBI SAVE/RESTORE. Send error message and exit
         WTOPC TEXT='QSBE: PBI not saved/restored from .... FOR TEST CAX
               SE ..',                                                 X
               SUB=(CHARA,(R2),DECA,EBW000),                           X
               LET=E,NUM=94,PREFIX=SOLD
         EXITC ,
         SPACE
RETERR   DS    0H
* Bad return value.  Send error message and exit
         WTOPC TEXT='QSBE: BAD RETURN VALUE FROM .... FOR TEST CASE ..'X
               ,SUB=(CHARA,(R2),DECA,EBW000),                          X
               LET=E,NUM=91,PREFIX=SOLD
         EXITC ,
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST32  DS  0F
         DC  F'-2003'    All following values must add to this number
         DC  F'621'
         DC  F'-185324'
         DC  F'5'
         DC  F'16547'
         DC  F'166148'
         SPACE 1
SUM60    DS  0F
         DC  F'11174'    The sum of CONST60
         SPACE 1
CASE60RET DS 0F
         DC  F'0'
         DC  F'-1'
         DC  F'42'
         DC  F'5000000'
         DC  F'1234567890'
         DC  F'-1234567890'
         DC  F'2042004'
         DC  F'5'
         LTORG
         FINIS
         END
