         PRINT NOGEN
         BEGIN NAME=QSBF,IBM=NO,AMODE=31,BASE=NONE
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSBF                                               *
* DESCRIPTION..... Assembler program, part of QSBA BSO                *
*                                                                     *
* FUNCTION... 31-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 31-bit assembler program with no      *
*    program base register and no transfer vectors.                   *
*                                                                     *
*    This module contains code for test cases:                        *
*      26, 31, 52, 55, 56, 57                                         *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         L     R14,EBW000      Test to see which test case this is
         CHI   R14,26          Is it test case 26?
         JE    CASE26          Yes, go do it
         CHI   R14,31          Is it test case 31?
         JE    CASE31          Yes, go do it
         CHI   R14,52          Is it test case 52?
         JE    CASE52          Yes, go do it
         CHI   R14,55          Is it test case 55?
         JE    CASE55          Yes, go do it
         CHI   R14,56          Is it test case 56?
         JE    CASE56          Yes, go do it
         CHI   R14,57          Is it test case 57?
         JE    CASE57          Yes, go do it
         J     CASEERR         Invalid test case number

CASE26   DS    0H
         JAS   R15,PARMVAL     Check validity of parameters
         ENTRC QSBC            Enter QSBC (inter-BAL call)
         LR    R0,R7
         BACKC ,               Return to caller

CASE31   DS    0H
         JAS   R15,PARMVAL        Check parameters
         ENTRC QSB8               Enter QSB8
         LARL  R14,=C'QSB8'
         MVC   EBX000(4),0(R14)   Prep for error routine
         LARL  R15,=C'P'
         CLM   R7,B'0001',0(R15)  Check to see if case passed
         JNE   RETERR             No, issue error
         BACKC ,

CASE52   DS    0H
CASE56   DS    0H
         JAS   R15,PARMVAL        Check parameters
         ENTRC QCE1               Enter C entry QCE1
         XR    R7,R7              Zero out register
         LLILL R7,C'P'            Test case passed
         BACKC ,

CASE55   DS    0H
CASE57   DS    0H
         JAS   R15,PARMVAL        Check parameters
         XR    R7,R7              Zero out register
         LLILL R7,C'P'            Test case passed
         BACKC ,

PARMVAL  DS    0H
         LR    R14,R4             Add
         AR    R14,R5              register
         AR    R14,R6               values
         CR    R0,R14             Compare sum to value in r0
         JNE   PARMERR            If the sum isn't good, throw error
         BR    R15

PARMERR  DS    0H
* Bad parameters passed. Issue error and exit
         WTOPC TEXT='QSBF: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC ,
         SPACE

CASEERR  DS    0H
* Bad test case number.  Send error message and exit
         WTOPC TEXT='QSBF: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
         SPACE

RETERR   DS    0H
* Bad return value. Send error and exit
         WTOPC TEXT='QSBA: BAD RETURN VALUE FROM .... FOR TEST CASE ..'X
               ,SUB=(CHARA,(R2),DECA,EBW000),                          X
               LET=E,NUM=91,PREFIX=SOLD
         EXITC ,
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
CONST31  DS  0F
         DC  F'783186'
         DC  F'768743'
         DC  F'2349'
         DC  F'3248'
         DC  F'8756'
         DC  F'90'
         LTORG
         FINIS
         END
