/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QSC1 (qsc1b)                                     */
/* DESCRIPTION..... This module is a library of functions for the    */
/*                  Shared Object Linkage Driver (SOLD) test cases.  */
/*                  This is one function contained in the library.   */
/*                                                                   */
/* FUNCTION... qsc1b is a function called by test cases              */
/*                     3, 10                                         */
/*             of the SOLD driver. The test case number is passed to */
/*             this function via the ECB workarea field EBW000.      */
/*             Six chars and a function pointer are passed to this   */
/*             function.  There is no direct parameter checking in   */
/*             this function, but the chars and directly passed to   */
/*             the function passed in.  That function will check     */
/*             them and they should be 'a' 'b' 'c' 'd' 'e' 'f'       */
/*             passed in that order.  The return value is 'P' if     */
/*             successful, 'F' otherwise.                            */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....                                                        */
/*                                                                   */
/* NORMAL RETURN... 'P'                                              */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/
#include <c_sold.h>
#include <tpf/tpfapi.h>
#include <stdio.h>

char qsc1b(char c1, char c2, char c3, char c4, char c5, char c6,
	   char (*func)(char, char, char, char, char, char, char *))
{
  char retval = 'P';                                                            //C64JK

  switch(test_case) {
  case(3):
  case(10):
    retval = func(c1, c2, c3, c4, c5, c6, "abcdef");                            //C64JK
    if( retval != 'P' ) {                                                       //C64JK
      bad_return_msg("QSC1", "QSC3", test_case);                                //C64JK
    }
    break;
  }

  return retval;                                                                //C64JK
}
