/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QSC1TRACE                                        */
/* DESCRIPTION.....                                                  */
/* FUNCTION...                                                       */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....                                                        */
/*                                                                   */
/* NORMAL RETURN...                                                  */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/

#include <stdarg.h>
#include <c_sold.h>
#include <tpf/tpfapi.h>

/*-------------------------------------------------------------------*/
/* Set up an external variable so routines that return void do not   */
/* get optimized out of existence                                    */
/*-------------------------------------------------------------------*/
int externalx = 0;          /* used as an external variable          */

/*-------------------------------------------------------------------*/
/* Subroutines to test char parameters and char return parameter     */
/*-------------------------------------------------------------------*/
char testchar1(char zz10){
   char x = 'J';
   return(x);
}

char testchar2(char zz21, char zz22){
   char x = 'K';
   return(x);
}

char testchar3(char zz31, char zz32, char zz33){
   char x = 'L';
   return(x);
}

char testchar4(char zz41, char zz42, char zz43, char zz44){
   char x = 'M';
   return(x);
}

char testchar5(char zz51, char zz52, char zz53, char zz54,
               char zz55){
   char x = 'N';
   return(x);
}

char testchar6(char zz61, char zz62, char zz63, char zz64,
               char zz65, char zz66){
   char x = 'O';
   return(x);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned char parameters and                  */
/* unsigned char return parameter                                    */
/*-------------------------------------------------------------------*/
unsigned char testuchar1(unsigned char zz10){
   unsigned char x = 'J';
   return(x);
}

unsigned char testuchar2(unsigned char zz21, unsigned char zz22){
   unsigned char x = 'K';
   return(x);
}

unsigned char testuchar3(unsigned char zz31, unsigned char zz32,
                         unsigned char zz33){
   unsigned char x = 'L';
   return(x);
}

unsigned char testuchar4(unsigned char zz41, unsigned char zz42,
                         unsigned char zz43, unsigned char zz44){
   unsigned char x = 'M';
   return(x);
}

unsigned char testuchar5(unsigned char zz51, unsigned char zz52,
                         unsigned char zz53, unsigned char zz54,
                         unsigned char zz55){
   unsigned char x = 'N';
   return(x);
}

unsigned char testuchar6(unsigned char zz61, unsigned char zz62,
                         unsigned char zz63, unsigned char zz64,
                         unsigned char zz65, unsigned char zz66){
   unsigned char x = 'P';
   return(x);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test short parameters and short return parameter   */
/*-------------------------------------------------------------------*/
short testshort1(short zz10){
   return(zz10);
}

short testshort2(short zz21, short zz22){
   return(zz21 + zz22);
}

short testshort3(short zz31, short zz32, short zz33){
   return(zz31 + zz32 + zz33);
}

short testshort4(short zz41, short zz42, short zz43, short zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

short testshort5(short zz51, short zz52, short zz53,
                 short zz54, short zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

short testshort6(short zz61, short zz62, short zz63,
                 short zz64, short zz65, short zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned short parameters and                 */
/* unsigned short return parameter                                   */
/*-------------------------------------------------------------------*/
unsigned short testushort1(unsigned short zz10){
   return(zz10);
}

unsigned short testushort2(unsigned short zz21, unsigned short zz22){
   return(zz21 + zz22);
}

unsigned short testushort3(unsigned short zz31, unsigned short zz32,
                           unsigned short zz33){
   return(zz31 + zz32 + zz33);
}

unsigned short testushort4(unsigned short zz41, unsigned short zz42,
                           unsigned short zz43, unsigned short zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

unsigned short testushort5(unsigned short zz51, unsigned short zz52,
                           unsigned short zz53, unsigned short zz54,
                           unsigned short zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

unsigned short testushort6(unsigned short zz61, unsigned short zz62,
                           unsigned short zz63, unsigned short zz64,
                           unsigned short zz65, unsigned short zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test int parameters and int return parameter   */
/*-------------------------------------------------------------------*/
int testint1(int zz10){
   return(zz10);
}

int testint2(int zz21, int zz22){
   return(zz21 + zz22);
}

int testint3(int zz31, int zz32, int zz33){
   return(zz31 + zz32 + zz33);
}

int testint4(int zz41, int zz42, int zz43, int zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

int testint5(int zz51, int zz52, int zz53, int zz54, int zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

int testint6(int zz61, int zz62, int zz63, int zz64, int zz65,int zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned int parameters and                   */
/* unsigned int return parameter                                     */
/*-------------------------------------------------------------------*/
unsigned int testuint1(unsigned int zz10){
   return(zz10);
}

unsigned int testuint2(unsigned int zz21, unsigned int zz22){
   return(zz21 + zz22);
}

unsigned int testuint3(unsigned int zz31, unsigned int zz32,
                       unsigned int zz33){
   return(zz31 + zz32 + zz33);
}

unsigned int testuint4(unsigned int zz41, unsigned int zz42,
                       unsigned int zz43,
              unsigned int zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

unsigned int testuint5(unsigned int zz51, unsigned int zz52,
                       unsigned int zz53, unsigned int zz54,
                       unsigned int zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

unsigned int testuint6(unsigned int zz61, unsigned int zz62,
                       unsigned int zz63, unsigned int zz64,
                       unsigned int zz65, unsigned int zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test long parameters and long return parameter     */
/*-------------------------------------------------------------------*/
long testlong1(long zz10){
   return(zz10);
}

long testlong2(long zz21, long zz22){
   return(zz21 + zz22);
}

long testlong3(long zz31, long zz32, long zz33){
   return(zz31 + zz32 + zz33);
}

long testlong4(long zz41, long zz42, long zz43, long zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

long testlong5(long zz51, long zz52, long zz53, long zz54,
               long zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

long testlong6(long zz61, long zz62, long zz63, long zz64,
               long zz65, long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned long parameters and                  */
/* unsigned long return parameter                                    */
/*-------------------------------------------------------------------*/
unsigned long testulong1(unsigned long zz10){
   return(zz10);
}

unsigned long testulong2(unsigned long zz21, unsigned long zz22){
   return(zz21 + zz22);
}

unsigned long testulong3(unsigned long zz31, unsigned long zz32,
                         unsigned long zz33){
   return(zz31 + zz32 + zz33);
}

unsigned long testulong4(unsigned long zz41, unsigned long zz42,
                         unsigned long zz43, unsigned long zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

unsigned long testulong5(unsigned long zz51, unsigned long zz52,
                         unsigned long zz53, unsigned long zz54,
                         unsigned long zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

unsigned long testulong6(unsigned long zz61, unsigned long zz62,
                         unsigned long zz63, unsigned long zz64,
                         unsigned long zz65, unsigned long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test long long parameters                          */
/* and long long return parameter                                    */
/*-------------------------------------------------------------------*/
long long testlonglong1(long long zz10){
   return(zz10);
}

long long testlonglong2(long long zz21, long long zz22){
   return(zz21 + zz22);
}

long long testlonglong3(long long zz31, long long zz32,
                        long long zz33){
   return(zz31 + zz32 + zz33);
}

long long testlonglong4(long long zz41, long long zz42,
                        long long zz43, long long zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

long long testlonglong5(long long zz51, long long zz52,
                        long long zz53, long long zz54,
                        long long zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

long long testlonglong6(long long zz61, long long zz62,
                        long long zz63, long long zz64,
                        long long zz65, long long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test unsigned long long parameters and             */
/* unsigned long long return parameter                               */
/*-------------------------------------------------------------------*/
unsigned long long testulonglong1(unsigned long long zz10){
   return(zz10);
}

unsigned long long testulonglong2(unsigned long long zz21,
         unsigned long long zz22){
   return(zz21 + zz22);
}

unsigned long long testulonglong3(unsigned long long zz31,
         unsigned long long zz32, unsigned long long zz33){
   return(zz31 + zz32 + zz33);
}

unsigned long long testulonglong4(unsigned long long zz41,
         unsigned long long zz42, unsigned long long zz43,
         unsigned long long zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

unsigned long long testulonglong5(unsigned long long zz51,
         unsigned long long zz52, unsigned long long zz53,
         unsigned long long zz54, unsigned long long zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

unsigned long long testulonglong6(unsigned long long zz61,
         unsigned long long zz62, unsigned long long zz63,
         unsigned long long zz64, unsigned long long zz65,
         unsigned long long zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test float parameters and float return parameter */
/*-------------------------------------------------------------------*/
 float testfloat1( float zz10){
   return(zz10);
}

 float testfloat2( float zz21, float zz22){
   return(zz21 + zz22);
}

 float testfloat3( float zz31, float zz32, float zz33){
   return(zz31 + zz32 + zz33);
}

 float testfloat4( float zz41, float zz42, float zz43,  float zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

 float testfloat5( float zz51, float zz52, float zz53,  float zz54,
                     float zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

 float testfloat6( float zz61, float zz62, float zz63,  float zz64,
                     float zz65, float zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test double parameters and double return parameter */
/*-------------------------------------------------------------------*/
 double testdouble1( double zz10){
   return(zz10);
}

 double testdouble2( double zz21, double zz22){
   return(zz21 + zz22);
}

 double testdouble3( double zz31, double zz32, double zz33){
   return(zz31 + zz32 + zz33);
}

 double testdouble4( double zz41, double zz42, double zz43,  double zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

 double testdouble5( double zz51, double zz52, double zz53,  double zz54,
                     double zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

 double testdouble6( double zz61, double zz62, double zz63,  double zz64,
                     double zz65, double zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test long double parameters and                    */
/* long double return parameter                                      */
/*-------------------------------------------------------------------*/
long double testlongdouble1(long double zz10){
   return(zz10);
}

long double testlongdouble2(long double zz21, long double zz22){
   return(zz21 + zz22);
}

long double testlongdouble3(long double zz31, long double zz32,
                            long double zz33){
   return(zz31 + zz32 + zz33);
}

long double testlongdouble4(long double zz41, long double zz42,
                            long double zz43, long double zz44){
   return(zz41 + zz42 + zz43 + zz44);
}

long double testlongdouble5(long double zz51, long double zz52,
          long double zz53, long double zz54, long double zz55){
   return(zz51 + zz52 + zz53 + zz54 + zz55);
}

long double testlongdouble6(long double zz61, long double zz62,
          long double zz63, long double zz64, long double zz65,
          long double zz66){
   return(zz61 + zz62 + zz63 + zz64 + zz65 + zz66);
}

/*-------------------------------------------------------------------*/
/* Subroutines to test var parameter                                 */
/*-------------------------------------------------------------------*/
int testvar3(char zz31, int zz32, ...) {
   va_list ap;
   va_start(ap, zz32);
   va_end(ap);
   return(zz32);
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test char parameters and char return parameter     */
/*-------------------------------------------------------------------*/
void testvoid1(void){
   externalx= 1;
   return;
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test typedef                                       */
/*-------------------------------------------------------------------*/
FREDINT testtypedef(FREDINT zz31, FREDCHAR zz32, FREDLONG zz33) {
   if (zz32 == 'C') return(zz31);
   else return(4);
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test structure in register                         */
/*-------------------------------------------------------------------*/
struct taskret teststructinreg(struct taskparm1 a1,
                               struct taskparm2 a2,
                               struct taskparm3 a3,
                               struct taskparm4 a4){

   struct taskret xxx;
   xxx.x = 15;
   xxx.a = 'X';

   struct taskret yyy;
   yyy.x = 31;
   yyy.a = 'Y';

   if (a1.b=='B')
      return(xxx);
   else
      return(yyy);
}


/*-------------------------------------------------------------------*/
/* Subroutine  to test structure in register and return int          */
/*-------------------------------------------------------------------*/
int teststructinreg2(struct taskparm1 a1,
                     struct taskparm2 a2,
                     struct taskparm3 a3,
                     struct taskparm4 a4){


   if (a1.b=='B')
      return(24);
   else
      return(36);
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test char structures in register and return int    */
/*-------------------------------------------------------------------*/
int teststructinreg3(struct taskcharparm1 a1,
                     struct taskcharparm2 a2,
                     struct taskcharparm3 a3,
                     struct taskcharparm4 a4){


   if (a1.jj=='B')
      return(24);
   else
      return(36);
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test char structures in register and return int    */
/*-------------------------------------------------------------------*/
struct taskret teststructinreg55(struct taskcharparm55 a1,
                                 struct taskcharparm44 a2,
                                 struct taskcharparm33 a3,
                                 struct taskcharparm22 a4,
                                 struct taskcharparm11 a5){


   struct taskret xxx55;
   xxx55.x = 15;
   xxx55.a = 'X';

   struct taskret yyy55;
   yyy55.x = 31;
   yyy55.a = 'Y';

   if (a1.j1=='B')
      return(xxx55);
   else
      return(yyy55);
}
/*-------------------------------------------------------------------*/
/* Subroutine  to test char structures in register and return int    */
/*-------------------------------------------------------------------*/
struct taskret teststructinreg66(struct taskcharparm66 a1,
                                 struct taskcharparm55 a2,
                                 struct taskcharparm44 a3,
                                 struct taskcharparm33 a4,
                                 struct taskcharparm22 a5,
                                 struct taskcharparm11 a6){

   struct taskret xxx66;
   xxx66.x = 15;
   xxx66.a = 'X';

   struct taskret yyy66;
   yyy66.x = 31;
   yyy66.a = 'Y';

   if (a1.j1=='B')
      return(xxx66);
   else
      return(yyy66);
}

/*-------------------------------------------------------------------*/
/* Subroutine  to test char structures in register and return int    */
/*-------------------------------------------------------------------*/
struct taskret teststructinreg66a(struct taskcharparm22 a1,
                                  struct taskcharparm11 a2,
                                  struct taskcharparm22 a3,
                                  struct taskcharparm11 a4,
                                  struct taskcharparm22 a5,
                                  struct taskcharparm11 a6){

   struct taskret xxx66a;
   xxx66a.x = 15;
   xxx66a.a = 'X';

   struct taskret yyy66a;
   yyy66a.x = 31;
   yyy66a.a = 'Y';

   if (a1.j1=='B')
      return(xxx66a);
   else
      return(yyy66a);
}
