/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QSC2 (qsc2a)                                     */
/* DESCRIPTION..... This module is a library of functions for the    */
/*                  Shared Object Linkage Driver (SOLD) test cases.  */
/*                  This is one function contained in the library.   */
/*                                                                   */
/* FUNCTION... qsc2a is a function called by test cases              */
/*                     2, 9                                          */
/*             of the SOLD driver. The test case number is passed to */
/*             this function via the ECB workarea field EBW000.  Six */
/*             integers and one function pointer are passed to this  */
/*             function. The ints should add up to 2003 and the      */
/*             function pointer is called as the next step in the    */
/*             test case. This function returns the sum of the       */
/*             parameters, which should be 2003.                     */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....                                                        */
/*                                                                   */
/* NORMAL RETURN... 2003                                             */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/
#include <tpf/tpfapi.h>
#include <stdio.h>
#include <c_sold.h>

int qsc2a(int i1, int i2, int i3, int i4, int i5, int i6,
	  int (*func)(short int, short int,
		      unsigned short int, unsigned short int))
{
  int sum = i1 + i2 + i3 + i4 + i5 + i6;                                        //C64JK

  struct pat *pat_addr;                                                         //d10433f_1
  char prog_name[PAT_PROG_NAME_LEN+PAT_VERS_CODE_LEN+1] = {0};                  //d10875

  if (test_mode == SHOW_VER)  {                                                 //f5555
     pat_addr = (void*) tpf_ecbp3()->ce3patg;                                   //f12472
     memcpy(prog_name, pat_addr->patname, PAT_PROG_NAME_LEN+PAT_VERS_CODE_LEN); //d10875
     show_prog_version(prog_name, pat_addr->patacnum);                          //f12305
  }

  if( sum != 2003 ) {                                                           //C64JK
    bad_param_msg("QSC2", test_case);                                           //C64JK
  }

  if( !func(33000, 40000, 50000, 60000) ) {                                     //C64JK
     bad_return_msg("QSC2", "QSC2", test_case);                                 //C64JK
  }

  return sum;                                                                   //C64JK
}
