/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QSC3 (qsc3b)                                     */
/* DESCRIPTION..... This module is a library of functions for the    */
/*                  Shared Object Linkage Driver (SOLD) test cases.  */
/*                  This is one function contained in the library.   */
/*                                                                   */
/* FUNCTION... qsc3b is a function called by test cases              */
/*                     1, 6, 7, 60                                   */
/*             of the SOLD driver. The test case number is passed to */
/*             this function via the ECB workarea field EBW000.      */
/*             Six integers and one pointer to an integer are passed */
/*             to this function. The six integers must add up to the */
/*             value of the pointer.  The return value is 1 if       */
/*             successful, 0 otherwise.                              */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....                                                        */
/*                                                                   */
/* NORMAL RETURN... 1                                                */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/
#include <c_sold.h>

void QCE3(void);                                                                //C64JK

int qsc3b( int i1, int i2, int i3, int i4, int i5, int i6, int * ans )
{
  int sum = i1 + i2 + i3 + i4 + i5 + i6;                                        //C64JK

  if( sum != *ans ) {                                                           //C64JK
    bad_param_msg("QSC3", test_case);                                           //C64JK
  }

  switch(test_case) {
     case 1:
     case 6:
     case 7:
        /* End of the line */
        break;
     case 12:                                                                   //C64CF
     case 60:
        QCE3();                                                                 //C64JK
        break;
     default:
        bad_case_msg("QSC3", test_case);                                        //C64JK
  }

  return 1;
}
