/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/* BKopac           05/12/04              Created boundary tests for */
/*                                        very long function names.  */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QSCD98                                           */
/* DESCRIPTION..... This function is used for individual test case   */
/*                  invocation for the Shared Object Linkage         */
/*                  Driver (SOLD) for testcase 14.                   */
/*                  ZTEST SOLD CASE-14                               */
/*                                                                   */
/* FUNCTION... This source file contains utility functions to print  */
/*             out common error messages and exit the driver.        */
/*             The testcase tests very long function names that have */
/*             greater than 2000 characters.                         */
/*                                                                   */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....       VOID                                             */
/*                                                                   */
/* NORMAL RETURN... VOID                                             */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/
/* CHANGE ACTIVITY...                                                */
/*                                                                   */
/*        UPDATE BY     PLOG #   DATE     DESCRIPTION                */
/*        ---------     -------  ------   ------------               */
/*                                                                   */
/*********************************************************************/

#include <c_sold.h>                                                             //CRK7298


void very_long_function_name(void) {                                            //CRK7298

    int sum = 0;                                                                //CRK7298

    if (test_case != 14) {                                                      //CRK7298
       bad_case_msg("QSCD98", test_case);                                       //CRK7298
    }                                                                           //CRK7298

    sum = LONG_FUNCTION_NAME_2052(test_case);                                   //CRK7298

      if (sum !=  14) {                                                         //CRK7298
       bad_case_msg("QSCD98", sum);                                             //CRK7298
    }                                                                           //CRK7298

    return;
}

/*---------------------------------------------------------------------------*/ //CRK7298
/* Subroutines to test tracing of very long function names greater than      */ //CRK7298
/* 2000 characters.                                                          */ //CRK7298
/*---------------------------------------------------------------------------*/ //CRK7298

int  LONG_FUNCTION_NAME_2045(int x) {                                           //CRK7298
     x = test_case;                                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_2046(int x) {                                           //CRK7298
     x = LONG_FUNCTION_NAME_2045(x);                                            //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_2047(int x) {                                           //CRK7298
     x = LONG_FUNCTION_NAME_2046(x);                                            //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_2048(int x) {                                           //CRK7298
     x = LONG_FUNCTION_NAME_2047(x);                                            //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_2049(int x) {                                           //CRK7298
     x = LONG_FUNCTION_NAME_2048(x);                                            //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  t(int x){                     /* single-character function name      */    //CRK7298
     x = LONG_FUNCTION_NAME_2049(x);                                            //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_2050(int x) {                                           //CRK7298
     x = t(x);                     /* call single-character function name */    //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_2051(int x) {                                           //CRK7298
     x = LONG_FUNCTION_NAME_2050(x);                                            //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_2052(int x) {                                           //CRK7298
     x = LONG_FUNCTION_NAME_2051(x);                                            //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298
