/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/* BKopac        05/12/04                 Added boundary tests for   */         //CRK7298
/*                                        long function names with   */         //CRK7298
/*                                        255 or more characters.    */         //CRK7298
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* MODULE NAME..... QSCD99                                           */
/* DESCRIPTION..... This function is used for individual test case   */
/*                  invocation for the Shared Object Linkage         */
/*                  Driver (SOLD) for testcase 13.                   */
/*                  ZTEST SOLD CASE-13                               */
/*                                                                   */
/* FUNCTION... This source file contains utility functions to print  */
/*             out common error messages and exit the driver.        */
/*             The testcase tests long function names that have      */
/*             greater than 255 or greater characters.               */         //CRK7298
/*                                                                   */
/*                                                                   */
/* RESTRICTIONS....                                                  */
/*                                                                   */
/* INPUT.....       VOID                                             */
/*                                                                   */
/* NORMAL RETURN... VOID                                             */
/*                                                                   */
/* ERROR RETURN....                                                  */
/*                                                                   */
/* EXTERNAL ROUTINES.....                                            */
/*                                                                   */
/*********************************************************************/
/* CHANGE ACTIVITY...                                                */
/*                                                                   */
/*        UPDATE BY     PLOG #   DATE     DESCRIPTION                */
/*        ---------     -------  ------   ------------               */
/*                                                                   */
/*********************************************************************/

#include <c_sold.h>


void LONG_FUNCTION_NAME(void) {

    int sum = 0;                                                                //CRK7298

    if (test_case != 13) {                                                      //C64CF
       bad_case_msg("QSCD99", test_case);                                       //C64CF
    }                                                                           //C64CF

    sum = LONG_FUNCTION_NAME_766(test_case);                                    //CRK7298

       if (sum !=  13) {                                                        //CRK7298
          bad_case_msg("QSCD99", sum);                                          //CRK7298
       }                                                                        //CRK7298

    return;
}

/*---------------------------------------------------------------------------*/ //CRK7298
/* Subroutines to test tracing of long function names                        */ //CRK7298
/*---------------------------------------------------------------------------*/ //CRK7298

int  LONG_FUNCTION_NAME_255(int x) {                                            //CRK7298
                                                                                //CRK7298
     x = test_case;                                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_256(int x) {                                            //CRK7298
                                                                                //CRK7298
     x = LONG_FUNCTION_NAME_255(x);                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_509(int x) {                                            //CRK7298
                                                                                //CRK7298
     x = LONG_FUNCTION_NAME_256(x);                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_510(int x) {                                            //CRK7298
                                                                                //CRK7298
     x = LONG_FUNCTION_NAME_509(x);                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_511(int x) {                                            //CRK7298
                                                                                //CRK7298
     x = LONG_FUNCTION_NAME_510(x);                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_764(int x) {                                            //CRK7298
                                                                                //CRK7298
     x = LONG_FUNCTION_NAME_511(x);                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_765(int x) {                                            //CRK7298
                                                                                //CRK7298
     x = LONG_FUNCTION_NAME_764(x);                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  s(int x) {                       /* single-character function name */      //CRK7298
     x = LONG_FUNCTION_NAME_765(x);                                             //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298

int  LONG_FUNCTION_NAME_766(int x) {                                            //CRK7298

     x = s(x);                        /* call 1-character function name */      //CRK7298
     return(x);                                                                 //CRK7298
}                                                                               //CRK7298
