         PRINT NOGEN
         BEGIN NAME=QSWP,IBM=NO,AMODE=31
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME..... QSWP                                               *
* DESCRIPTION..... Assembler program, part of QSBE BSO                *
*                                                                     *
* FUNCTION... 31-bit assembler program to test out linkages           *
*                                                                     *
*    This function represents a 31-bit assembler program with a       *
*    program base register and no transfer vectors.                   *
*    The primary use for this function is the CROSC test case.        *
*                                                                     *
*    This module contains code for test cases:                        *
*      34                                                             *
*                                                                     *
*    For more information on these test cases, see qsca.c.            *
*                                                                     *
* MODULE ATTRIBUTES..                                                 *
*   TYPE.......... 'E'                                                *
*   PROCESSOR..... SHARED                                             *
*   DEPENDENCY.... IS IT OBJECT SHIPPABLE ??   NO                     *
*   ENVIRONMENT... BASE, ISO-C                                        *
*   ENTRY POINT... LABEL(S)                     (ONE PER E.P.)        *
*                                                                     *
* ECB-CONVENTIONS.......(DESCRIBE ALL INTERNAL ECB USAGE)             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* REGISTER-CONVENTIONS..(DESCRIBE ALL INTERNAL REGISTER USAGE)        *
*                                                                     *
***********************************************************************
* INTERFACE REQUIREMENTS:                                             *
*                                                                     *
* -  TEST CASE NUMBER IS IN EBW000 FOR ALL SOLD SEGMENTS              *
*                                                                     *
* DEPENDENCIES... DESCRIBE EXTERNAL EVENTS AFFECTING EXECUTION        *
* RESTRICTIONS... DESCRIBE ANY ENVIRONMENTAL OR CONFIGURATION         *
*                 ITEMS                                               *
*                                                                     *
*  ECB          * INPUT..              * OUTPUT..                     *
* --------------*----------------------*----------------------        *
* WORK AREA.... *                      *                              *
* DATA LEVELS.. *                      *                              *
* REGISTERS.... *                      *                              *
*                                                                     *
***********************************************************************
         SPACE
         CLI    EBW008,X'03'          Show version mode?                f5555
         JNE    NOSHOW                                                  f5555
         LGHI   R12,X'2000'                                             f5555
         LG     R11,CE3PATG(R12,R9)                                     f12472
         IDSPAT REG=R11                                                 f5555
         WTOPC TEXT='EXECUTING BSO ......, ACN= ..',                   Xf12305
               SUB=(CHARA,PATNAME,DECA,PATACNUM)                        f12305
NOSHOW   DS    0H                                                       f5555
         L     R14,EBW000  Load the test case number
         CHI   R14,34      Case 34?
         JNE     CASEERR     No, issue error
CASE34   DS    0H
         CLI   EBCM01,C'A'  Subcase A?
         JE    SUBCASE_A
         CLI   EBCM01,C'B'  Subcase B?
         JE    SUBCASE_B
         CLI   EBCM01,C'C'  Subcase C?
         JE    SUBCASE_C
         J     CASEERR     No, issue error

         SPACE 1
**********************************************************************
*                                                                    *
*  SUBCASE CASE A                                                    *
*                                                                    *
*    Validate regester parm values                                   *
*    Report current PBI setting                                      *
*    Do ENTRC to self to add to ENTER/BACK stack                     *
*                                                                    *
**********************************************************************

SUBCASE_A DS    0H
         LR    R7,R1       Load the first value into R14
         AR    R7,R2       Add
         AR    R7,R3         in
         AR    R7,R4          remaining
         AR    R7,R5           registers

         CR    R0,R7       Is the sum what is expected?
         JNE   PARMERR     No, issue error
         MVI   EBCM01,C'B' Set for subcase B
         JAS   R5,SAY_SS
         ENTRC QSWP
         BACKC ,
         SPACE 1
**********************************************************************
*                                                                    *
*  SUBCASE CASE B                                                    *
*                                                                    *
*    Report current PBI setting                                      *
*    Issue CROSC ENTNC to test ENTNC/BACKC stack PBI processing      *
*                                                                    *
**********************************************************************
SUBCASE_B DS    0H
         JAS   R5,SAY_SS
         SPACE
         XR    R6,R6               CLEAR R6
         ICM   R6,B'0011',CE1PBI   CROSC TO SELF
         MVI   EBCM01,C'C' Set for subcase C
         CROSC ENTNC,PROGRAM=QSWP,INVAL=NOTAVAIL,IDLOC=R6
         SPACE 1
**********************************************************************
*                                                                    *
*  SUBCASE CASE C                                                    *
*                                                                    *
*     Report current PBI setting                                     *
**********************************************************************
SUBCASE_C DS    0H
         SPACE
         JAS   R5,SAY_SS
         BACKC
         SPACE 1
**********************************************************************
*                                                                    *
*  DISPLAY CURRENT SS                                                *
*                                                                    *
**********************************************************************
SAY_SS   DS     0H
         CLI   EBW008,1                   CONTINUOUS MODE?
         BZ    SKIPMSG_SS
         MS0UT REG=R6
         XR    R6,R6
         ICM   R6,B'0011',CE1PBI
         UATBC IDLOC=(R,SSI,R6),EXCD=SS_ERROR,INVLID=SS_ERROR,         X
               NOTAVL=SS_ERROR
         WTOPC TEXT='QSWP: CURRENT SS .... ',                          X
               SUB=(CHARA,MU0NAM),                                     X
               LET=I,NUM=101,PREFIX=SOLD
SKIPMSG_SS     DS   0H
         BR    R5
         DROP  R6
**********************************************************************
*                                                                    *
*  ERROR Returs                                                      *
*                                                                    *
**********************************************************************
SS_ERROR DS    0H
         WTOPC TEXT='QSWP: CROSC SS ERROR FOR TEST CASE ..',           X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=100,PREFIX=SOLD
               EXITC
NOTAVAIL DS    0H
         WTOPC TEXT='QSWP: CROSC ENTNC FAILED FOR TEST CASE ..',       X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=91,PREFIX=SOLD
               EXITC
CASEERR  DS    0H
* Bad test case number.  Send error message and exit
         WTOPC TEXT='QSWP: INVALID TEST CASE NUMBER ..',               X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=93,PREFIX=SOLD
         EXITC ,
PARMERR  DS    0H
* Bad parameters. Send error message and exit
         WTOPC TEXT='QSWP: PARAMETER PASSING ERROR IN TEST CASE ..',   X
               SUB=(DECA,EBW000),                                      X
               LET=E,NUM=92,PREFIX=SOLD
         EXITC
         SPACE
***********************************************************************
*                                                                     *
* CONSTANTS & PARMLISTS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
         LTORG
         FINIS
         END
